#include "AST.h"


void ReturnNode::codeGen( CodeContext &context )
{
    // Must evaluate return value before unwinding exception stack,
    // since the act of evaluating may itself throw an exception.
    
    const string returnValue = expr()->absent()
	? string("void") : expr()->defineTemporary( context );
    unwindReturn( context, returnValue );
}
