#include "../AST.h"
#include "../ClassDecl.h"
#include "../MethodDecl.h"
#include "../utils.h"
#include "CtDescriptor.h"
#include "CtRegistry.h"


CtDescriptor::CtDescriptor( ClassDecl &basis )
  : CtClass( mangle( basis ), basis )
{
}


void CtDescriptor::defineHeaderFields( ostream &out ) const
{
  out << "enum TypeCategory category;\n";
}


const string CtDescriptor::mangle( ClassDecl &basis )
{
  return "cl_" + basis.fullName('_') + "_desc";
}


// Local Variables:
// c-file-style: "gnu"
// End:
