#include "../code-files/CfLayout.h"
#include "CtReference.h"


CtReference::CtReference( const char prefix[], const CtType &referent )
  : CtDefined( prefix + ('_' + referent.name) ),
    referent( referent )
{
}


void CtReference::elaborate( CfLayout &out ) const
{
  referent.declare( out );
}


// Local Variables:
// c-file-style: "gnu"
// End:
