#include "gc.h"
#include "native-str-utils.h"


typedef    cl_java_lang_Float    Float;
typedef GP_cl_java_lang_Float GP_Float;


GP_Float cl_java_lang_Float_mt_valueOf_GP_cl_java_lang_String(GP_cl_java_lang_String s)
{
    const jdouble value = stringToDouble(s);

    GP_Float result;
    Float *newbie = (Float *) ti_malloc( sizeof( Float ) );
    cl_java_lang_Float_mt_Float_jfloat( newbie, value );
    
    globalize( result, newbie );
    return result;
}


jint cl_java_lang_Float_mt_floatToIntBits_jfloat( jfloat value )
{
    /* !! This may not give the same bit representation
       as Java, particularly for Inf and NaN.
       */
    assert( sizeof(jfloat) == sizeof(jint) );
    return *((jint *) &value);
}


jfloat cl_java_lang_Float_mt_intBitsToFloat_jint( jint bits )
{
    assert( sizeof(jfloat) == sizeof(jint) );
    return *((jfloat *) &bits);
}


GP_cl_java_lang_String cl_java_lang_Float_mt_toString_jfloat( jfloat value )
{
    return doubleToString( value );
}
