#include <math.h>
#include "config.h"


#define func1( f )								\
jdouble cl_java_lang_Math_mt_ ## f ## _jdouble( jdouble value )			\
{										\
    return f( value );								\
}

#define func2( f )								\
jdouble cl_java_lang_Math_mt_ ## f ## _jdouble_jdouble( jdouble x, jdouble y )	\
{										\
    return f( x, y );								\
}


func1( acos )
func1( asin )
func1( atan )
func1( ceil )
func1( cos )
func1( exp )
func1( floor )
func1( log )
func1( rint )
func1( sin )
func1( sqrt )
func1( tan )

#ifdef HAVE_DREM
#define IEEEremainder drem
#else
#ifdef HAVE_REMAINDER
#define IEEEremainder remainder
#else
#error Cannot locate IEEE remainder function.
#endif
#endif

func2( IEEEremainder )
func2( atan2 )
func2( pow )
