package ti.domains;

//
// =============================
// Rect Domain List and Iterator
// =============================
//

public class tiRectDomainList1 {

  public tiRectDomainList1() {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
  }

  public tiRectDomainList1(tiRectDomainList1 dl) {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
    tiRectDomainListItem1 item;
    for (item = dl.rectDomainListHead; item != null; item = item.next) {
      append(item.rectDomain);
    }
  }

  public boolean isEmpty() { return (rectDomainListHead == null); }

  public void append(tiRectDomain1 rd) {
    tiRectDomainListItem1 newItem;

    newItem = new tiRectDomainListItem1();
    newItem.rectDomain = rd;
    newItem.next = null;
    if (rectDomainListHead == null) {
      rectDomainListHead = newItem;
    } else {
      rectDomainListTail.next = newItem;
    }
    rectDomainListTail = newItem;
    numItems++;
  }

  public void append(tiDomain1 d) {
    for (tiRectDomainListIterator1 iter =
	   d.getRectangles().newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      append(iter.dereference());
    }
  }

  public tiRectDomainListIterator1 newIterator() {
    return new tiRectDomainListIterator1(rectDomainListHead);
  }

  public tiRectDomain1 getSingularity() {
    if (rectDomainListHead == rectDomainListTail) {
      if (rectDomainListHead == null) {
	return new tiRectDomain1();
      } else {
	return rectDomainListHead.rectDomain;
      }
    } else {
      System.out.println("Runtime: (Internal Error) Attempted to get a singularity from a RectDomain list when none existed.");
      return new tiRectDomain1();
    }
  }

  public boolean hasSingularity() {
    return (rectDomainListHead == rectDomainListTail);
  }

  public int getNumItems() {
    return numItems;
  }

  public tiRectDomainListIterator1 newIterator(tiRectDomainListIterator1 iter) {
    return new tiRectDomainListIterator1(iter);
  }

  private tiRectDomainListItem1 rectDomainListHead;
  private tiRectDomainListItem1 rectDomainListTail;
  private int numItems;
}
