package ti.domains;

//
// =============================
// Rect Domain List and Iterator
// =============================
//

public class tiRectDomainListIterator3 {
  public tiRectDomainListIterator3(tiRectDomainListItem3 item) {
    rectDomainListItem = item;
    initialRectDomainListItem = item;
  }
  public tiRectDomainListIterator3(tiRectDomainListIterator3 iter) {
    rectDomainListItem = iter.rectDomainListItem;
    initialRectDomainListItem = iter.initialRectDomainListItem;
  }
  public tiRectDomainListIterator3 advance() {
    if (rectDomainListItem == null) {
      rectDomainListItem = null;
    } else {
      rectDomainListItem = rectDomainListItem.next;
    }
    return this;
  }
  public tiRectDomain3 dereference() {
    if (rectDomainListItem == null) {
      System.out.println("Runtime: (Internal Error) dereferenced a null RectDomain iterator.");
      return new tiRectDomain3();
    } else {
      return rectDomainListItem.rectDomain;
    }
  }
  public void rewind() { rectDomainListItem = initialRectDomainListItem; }
  public boolean isEnd() { return (rectDomainListItem == null); }

  public tiRectDomainListItem3 get() { return rectDomainListItem; }

  private tiRectDomainListItem3 initialRectDomainListItem;
  private tiRectDomainListItem3 rectDomainListItem;
}
