#ifndef _include_CtType_inlines_h_
#define _include_CtType_inlines_h_


#include <iostream>
#include <string>
#include "CtType.h"


inline void CtType::print( ostream &out ) const
{
  out << name;
}


inline ostream & operator << ( ostream &out, const CtType &type )
{
  type.print( out );
  return out;
}


inline string operator + ( const string &text, const CtType &type )
{
  return text + type.name;
}


inline string & operator += ( string &text, const CtType &type )
{
  return text += type.name;
}


inline bool operator < ( const CtType &first, const CtType &second )
{
  return first.name < second.name;
}


inline bool operator == ( const CtType &first, const CtType &second )
{
  return first.name == second.name;
}


#endif // !_include_CtType_inlines_h_


// Local Variables:
// c-file-style: "gnu"
// End:
