#include <iostream.h>
#include "stats.h"


LocalStats::LocalStats()
  : changed( 0 ),
    unchanged( 0 )
{
}


void LocalStats::print( ostream &sink ) const
{
  const unsigned total = changed + unchanged;
  const double percent = 100.0 * changed / total;

  sink << changed << " changed, "
       << unchanged << " unchanged, "
       << total << " total, "
       << percent << " %";
}
