#ifndef _INCLUDE_TITANIUM_LOCAL_STATS_H_
#define _INCLUDE_TITANIUM_LOCAL_STATS_H_


class LocalStats
{
public:
  LocalStats();
  void record( bool );
  void print( ostream & ) const;

private:
  unsigned changed, unchanged;
};


inline ostream & operator << ( ostream &sink, const LocalStats &stats )
{
  stats.print( sink );
  return sink;
}


inline void LocalStats::record( bool wasChanged )
{
  if (wasChanged)
    ++changed;
  else
    ++unchanged;
}





#endif // !_INCLUDE_TITANIUM_LOCAL_STATS_H_
