
/*  A Bison parser, made from ../src/parser.yy
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	ABSTRACT	258
#define	BOOLEAN	259
#define	BREAK	260
#define	BROADCAST	261
#define	BYTE	262
#define	CASE	263
#define	CATCH	264
#define	CHAR	265
#define	CLASS	266
#define	CONTINUE	267
#define	DEFAULT	268
#define	DO	269
#define	DOUBLE	270
#define	DOMAIN	271
#define	ELSE	272
#define	EXTENDS	273
#define	FINAL	274
#define	FINALLY	275
#define	FLOAT	276
#define	FOR	277
#define	FROM	278
#define	FOREACH	279
#define	IF	280
#define	IMPLEMENTS	281
#define	IMPORT	282
#define	INSTANCEOF	283
#define	INT	284
#define	INTERFACE	285
#define	IMMUTABLE	286
#define	IN	287
#define	INLINE	288
#define	LOCAL	289
#define	LONG	290
#define	NATIVE	291
#define	NEW	292
#define	_NULL	293
#define	OPERATOR	294
#define	OVERLAP	295
#define	_PACKAGE	296
#define	PRIVATE	297
#define	PROTECTED	298
#define	PUBLIC	299
#define	PARTITION	300
#define	POINT	301
#define	RECTDOMAIN	302
#define	RETURN	303
#define	SHORT	304
#define	STATIC	305
#define	SUPER	306
#define	SWITCH	307
#define	SYNCHRONIZED	308
#define	SINGLE	309
#define	SGLOBAL	310
#define	THIS	311
#define	THROW	312
#define	THROWS	313
#define	TRANSIENT	314
#define	TRY	315
#define	VOID	316
#define	VOLATILE	317
#define	WHILE	318
#define	TRUE	319
#define	FALSE	320
#define	IDENTIFIER	321
#define	INT_LITERAL	322
#define	LONG_LITERAL	323
#define	FLOAT_LITERAL	324
#define	DOUBLE_LITERAL	325
#define	DOUBLE_DIM	326
#define	CHARACTER_LITERAL	327
#define	STRING_LITERAL	328
#define	EMPTY_DIM	329
#define	CAND	330
#define	COR	331
#define	EQ	332
#define	NE	333
#define	LE	334
#define	GE	335
#define	LSHIFTL	336
#define	ASHIFTR	337
#define	LSHIFTR	338
#define	PLUS_ASG	339
#define	MINUS_ASG	340
#define	MULT_ASG	341
#define	DIV_ASG	342
#define	REM_ASG	343
#define	LSHIFTL_ASG	344
#define	ASHIFTR_ASG	345
#define	LSHIFTR_ASG	346
#define	AND_ASG	347
#define	XOR_ASG	348
#define	OR_ASG	349
#define	PLUSPLUS	350
#define	MINUSMINUS	351
#define	GUARDS	352

#line 136 "../src/parser.yy"

#include <stdlib.h>
#include <stdarg.h>
#include "AST.h"
#include "errors.h"
#include "parse.h"
#include "tokens.h"

static void yyerror(const char* msg);

static TreeNode *newOperator(char *op, SourcePosn p);
/* Routines to check the validity of modifier flags.  Each routine */
/* takes a logical `or' of flag values and a source position to which */
/* to refer error messages. */
static void checkFieldModifiers (Common::Modifiers flags, SourcePosn posn);
static void checkConstantFieldModifiers (Common::Modifiers flags, 
					 SourcePosn posn);
static void checkMethodModifiers (Common::Modifiers flags, SourcePosn posn);
static void checkConstructorModifiers (Common::Modifiers flags, 
				       SourcePosn posn);
static void checkMethodSignatureModifiers (Common::Modifiers flags, 
				       	   SourcePosn posn);
static void checkInterfaceModifiers(Common::Modifiers flags, 
				    SourcePosn posn);
static TreeNode *addSynchronized(Common::Modifiers modifiers, TreeNode *body);


#line 167 "../src/parser.yy"
typedef union {
    SimpTerminalInfo SimpTerminal;  	/* Terminal symbols with only position. */
    TerminalInfo Terminal;		/* Terminal symbols with ASCII string data. */
    StrTerminalInfo StrTerminal;	/* Terminal symbols with Unicode string data. */
    CharTerminalInfo CharTerminal;	/* Terminal symbols with Unicode char data. */
    long Int;				/* Simple integer values */
    bool Bool;
    TreeNode* Tree;
    TypeNode* Type;
    CatchNode* Catch;
    llist<TreeNode*>* TreeList;
    llist<TypeNode*>* TypeList;
    llist<CatchNode*>* CatchList;
    Common::Modifiers Modifiers;
    llist<DeclaratorTuple>* DeclaratorList;
    TryNode *Try;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		664
#define	YYFLAG		-32768
#define	YYNTBASE	122

#define YYTRANSLATE(x) ((unsigned)(x) <= 352 ? yytranslate[x] : 260)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    87,     2,     2,     2,    98,    95,     2,    74,
    75,    93,    91,    80,    92,    81,    94,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    90,    82,    86,
    84,    85,    89,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    78,     2,    79,    97,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    76,    96,    77,    88,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    83,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
   120,   121
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     6,     8,    10,    12,    14,    16,    18,
    20,    23,    26,    28,    30,    32,    34,    36,    38,    41,
    44,    47,    49,    51,    53,    55,    58,    61,    63,    65,
    67,    69,    71,    73,    75,    77,    82,    87,    92,    96,
   100,   102,   104,   107,   109,   112,   115,   117,   119,   121,
   123,   127,   133,   140,   142,   144,   146,   149,   151,   153,
   155,   157,   160,   162,   165,   167,   171,   173,   175,   177,
   180,   182,   184,   186,   188,   193,   195,   197,   199,   202,
   204,   206,   208,   210,   212,   214,   216,   218,   220,   222,
   224,   226,   228,   230,   232,   236,   239,   244,   246,   248,
   259,   270,   272,   274,   276,   277,   280,   287,   289,   291,
   293,   297,   301,   303,   305,   308,   310,   314,   316,   318,
   329,   339,   341,   343,   349,   355,   358,   364,   366,   368,
   371,   375,   377,   380,   382,   384,   389,   399,   409,   413,
   418,   421,   423,   427,   429,   431,   435,   437,   439,   441,
   444,   446,   448,   452,   454,   456,   458,   460,   462,   464,
   466,   468,   470,   472,   476,   479,   481,   483,   485,   487,
   489,   491,   493,   499,   507,   513,   517,   519,   523,   525,
   528,   532,   535,   541,   549,   558,   560,   563,   565,   567,
   569,   571,   573,   575,   579,   586,   588,   589,   593,   599,
   601,   603,   607,   611,   615,   619,   621,   623,   629,   632,
   635,   639,   642,   644,   647,   653,   656,   661,   667,   669,
   674,   676,   678,   680,   682,   684,   686,   688,   692,   696,
   698,   700,   702,   704,   706,   708,   712,   715,   718,   721,
   724,   727,   730,   733,   736,   739,   742,   745,   748,   751,
   754,   757,   760,   763,   766,   769,   772,   775,   778,   781,
   784,   787,   790,   793,   796,   799,   802,   805,   809,   814,
   819,   821,   825,   829,   833,   837,   839,   844,   849,   851,
   853,   855,   859,   866,   871,   877,   881,   882,   884,   887,
   892,   895,   897,   899,   901,   904,   907,   911,   913,   915,
   917,   920,   923,   925,   927,   930,   933,   935,   937,   939,
   942,   945,   947,   950,   953,   955,   960,   965,   969,   973,
   977,   979,   983,   987,   989,   993,   999,  1001,  1003,  1005,
  1007,  1011,  1015,  1019,  1023,  1027,  1031,  1035,  1039,  1043,
  1047,  1051,  1055,  1061,  1063,  1065,  1069,  1073,  1077,  1081,
  1085,  1089,  1093,  1097,  1101,  1105,  1109,  1113,  1117,  1121,
  1125,  1129,  1133,  1137,  1141,  1145,  1147,  1152,  1153,  1157,
  1161,  1165,  1168,  1171,  1174
};

static const short yyrhs[] = {   134,
     0,    67,     0,    68,     0,    69,     0,    70,     0,    64,
     0,    65,     0,    72,     0,    73,     0,   125,     0,   125,
   128,     0,   126,   130,     0,   132,     0,   223,     0,   133,
     0,   132,     0,   133,     0,   129,     0,   129,   128,     0,
    83,   130,     0,    71,   130,     0,   131,     0,   259,     0,
    54,     0,    34,     0,    54,    34,     0,    34,    54,     0,
     4,     0,    10,     0,     7,     0,    49,     0,    29,     0,
    21,     0,    35,     0,    15,     0,    46,    86,   255,    85,
     0,    47,    86,   255,    85,     0,    16,    86,   255,    85,
     0,   135,   136,   137,     0,    41,   223,    82,     0,   259,
     0,   259,     0,   139,   136,     0,   259,     0,   138,   137,
     0,    82,   137,     0,   142,     0,   176,     0,   140,     0,
   141,     0,    27,   223,    82,     0,    27,   223,    81,    93,
    82,     0,   143,    11,   224,   146,   147,   148,     0,   144,
     0,   259,     0,   145,     0,   144,   145,     0,     3,     0,
    19,     0,    44,     0,    31,     0,    18,   126,     0,   259,
     0,    26,   169,     0,   259,     0,    76,   149,    77,     0,
   150,     0,   259,     0,   151,     0,   151,   150,     0,   152,
     0,   159,     0,   171,     0,   175,     0,   153,   124,   156,
    82,     0,   154,     0,   259,     0,   155,     0,   154,   155,
     0,    44,     0,    43,     0,    42,     0,    50,     0,    19,
     0,    54,     0,    55,     0,     3,     0,    36,     0,    53,
     0,    59,     0,    62,     0,    34,     0,    33,     0,   157,
     0,   156,    80,   157,     0,   224,   237,     0,   224,   237,
    84,   158,     0,   254,     0,   184,     0,   153,   124,   160,
    74,   164,    75,   237,   167,   162,   170,     0,   153,   161,
   160,    74,   164,    75,   237,   167,   162,   170,     0,   224,
     0,   226,     0,    61,     0,     0,   163,   162,     0,    40,
    74,   224,    80,   224,    75,     0,   165,     0,   259,     0,
   166,     0,   166,    80,   165,     0,   124,   224,   237,     0,
   168,     0,   259,     0,    58,   169,     0,   125,     0,   125,
    80,   169,     0,   187,     0,    82,     0,   153,   224,    74,
   164,    75,   167,    76,   172,   188,    77,     0,   153,   224,
    74,   164,    75,   167,    76,   188,    77,     0,   173,     0,
   174,     0,    56,    74,   231,    75,    82,     0,    51,    74,
   231,    75,    82,     0,    50,   187,     0,   143,    30,   224,
   177,   179,     0,   178,     0,   259,     0,    18,   169,     0,
    76,   180,    77,     0,   259,     0,   181,   180,     0,   182,
     0,   183,     0,   153,   124,   156,    82,     0,   153,   124,
   160,    74,   164,    75,   237,   167,    82,     0,   153,   161,
   160,    74,   164,    75,   237,   167,    82,     0,    76,   185,
    77,     0,    76,   185,    80,    77,     0,    76,    77,     0,
   186,     0,   185,    80,   186,     0,   254,     0,   184,     0,
    76,   188,    77,     0,   189,     0,   259,     0,   190,     0,
   189,   190,     0,   191,     0,   192,     0,   124,   156,    82,
     0,   193,     0,   194,     0,   195,     0,   197,     0,   202,
     0,   211,     0,   213,     0,   187,     0,   218,     0,    82,
     0,   224,    90,   192,     0,   196,    82,     0,   256,     0,
   243,     0,   244,     0,   240,     0,   241,     0,   230,     0,
   233,     0,    25,    74,   254,    75,   192,     0,    25,    74,
   254,    75,   192,    17,   192,     0,    52,    74,   254,    75,
   198,     0,    76,   199,    77,     0,   259,     0,   200,   189,
   199,     0,   201,     0,   201,   200,     0,     8,   257,    90,
     0,    13,    90,     0,    63,    74,   254,    75,   192,     0,
    14,   192,    63,    74,   254,    75,    82,     0,    22,    74,
   203,   253,    82,   204,    75,   192,     0,   207,     0,   205,
    82,     0,   191,     0,   206,     0,   259,     0,   206,     0,
   259,     0,   196,     0,   196,    80,   206,     0,    24,    74,
   209,    75,   208,   192,     0,    33,     0,     0,   224,   210,
   254,     0,   224,   210,   254,    80,   209,     0,    32,     0,
    66,     0,     5,   212,    82,     0,    12,   212,    82,     0,
    48,   253,    82,     0,    57,   254,    82,     0,   224,     0,
   259,     0,    53,    74,   254,    75,   192,     0,   214,   217,
     0,   214,   215,     0,   214,   215,   217,     0,    60,   187,
     0,   216,     0,   216,   215,     0,     9,    74,   166,    75,
   187,     0,    20,   187,     0,    45,    76,   219,    77,     0,
    45,   224,    76,   219,    77,     0,   259,     0,   254,   121,
   192,   219,     0,   223,     0,   221,     0,   233,     0,   222,
     0,   123,     0,    38,     0,    56,     0,    74,   254,    75,
     0,    74,   223,    75,     0,   227,     0,   229,     0,   230,
     0,   224,     0,   225,     0,    66,     0,   223,    81,    66,
     0,    39,    87,     0,    39,    88,     0,    39,    86,     0,
    39,    85,     0,    39,   103,     0,    39,   104,     0,    39,
   101,     0,    39,   102,     0,    39,    91,     0,    39,    92,
     0,    39,    93,     0,    39,    94,     0,    39,    95,     0,
    39,    96,     0,    39,    97,     0,    39,    98,     0,    39,
   105,     0,    39,   106,     0,    39,   107,     0,    39,   108,
     0,    39,   109,     0,    39,   110,     0,    39,   111,     0,
    39,   112,     0,    39,   113,     0,    39,   114,     0,    39,
   115,     0,    39,   116,     0,    39,   117,     0,    39,   118,
     0,    39,    83,     0,    39,    83,    84,     0,   223,    78,
   228,    79,     0,   222,    78,   228,    79,     0,   232,     0,
   220,    81,   160,     0,    51,    81,   160,     0,   127,    81,
   160,     0,   223,    81,   226,     0,   226,     0,   229,    74,
   231,    75,     0,   223,    74,   231,    75,     0,   232,     0,
   259,     0,   254,     0,   254,    80,   232,     0,    37,   234,
   126,    74,   231,    75,     0,    37,   234,   125,   235,     0,
    37,   234,   125,   235,   128,     0,    74,   254,    75,     0,
     0,   236,     0,   236,   235,     0,    78,   254,    79,   130,
     0,   248,   130,     0,   238,     0,   259,     0,    83,     0,
    83,    34,     0,   238,    83,     0,   238,    83,    34,     0,
   220,     0,   240,     0,   241,     0,   239,   119,     0,   239,
   120,     0,   243,     0,   244,     0,    91,   242,     0,    92,
   242,     0,   247,     0,   248,     0,   245,     0,   119,   242,
     0,   120,   242,     0,   239,     0,    88,   242,     0,    87,
   242,     0,   246,     0,    74,   124,    75,   242,     0,    74,
   223,    75,   245,     0,    78,   232,    79,     0,    78,   249,
    79,     0,    78,   251,    79,     0,   250,     0,   250,    80,
   249,     0,   254,    90,   254,     0,   252,     0,   252,    80,
   251,     0,   254,    90,   254,    90,   254,     0,   254,     0,
   259,     0,   255,     0,   258,     0,   254,    86,   254,     0,
   254,    85,   254,     0,   254,   103,   254,     0,   254,   104,
   254,     0,   254,    28,   124,     0,   254,   101,   254,     0,
   254,   102,   254,     0,   254,    95,   254,     0,   254,    96,
   254,     0,   254,    97,   254,     0,   254,    99,   254,     0,
   254,   100,   254,     0,   254,    89,   254,    90,   254,     0,
   256,     0,   242,     0,   255,    93,   255,     0,   255,    94,
   255,     0,   255,    98,   255,     0,   255,    91,   255,     0,
   255,    92,   255,     0,   255,   105,   255,     0,   255,   107,
   255,     0,   255,   106,   255,     0,   242,    84,   254,     0,
   242,   110,   254,     0,   242,   111,   254,     0,   242,   112,
   254,     0,   242,   108,   254,     0,   242,   109,   254,     0,
   242,   113,   254,     0,   242,   115,   254,     0,   242,   114,
   254,     0,   242,   116,   254,     0,   242,   117,   254,     0,
   242,   118,   254,     0,   254,     0,     6,   254,    23,   254,
     0,     0,    27,     1,    82,     0,    41,     1,    82,     0,
    76,     1,    77,     0,     1,    82,     0,     1,   187,     0,
     1,    82,     0,     1,   148,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   267,   272,   275,   277,   279,   281,   283,   285,   287,   294,
   295,   298,   302,   304,   306,   310,   312,   316,   318,   321,
   324,   334,   336,   339,   341,   342,   343,   346,   349,   351,
   353,   355,   357,   359,   361,   367,   370,   372,   381,   386,
   389,   393,   396,   401,   404,   406,   410,   412,   418,   420,
   423,   432,   444,   452,   454,   458,   460,   468,   471,   473,
   475,   482,   485,   492,   495,   503,   508,   510,   514,   516,
   523,   525,   527,   529,   536,   559,   561,   565,   567,   574,
   578,   580,   583,   585,   587,   589,   592,   594,   596,   599,
   601,   603,   605,   613,   615,   619,   622,   629,   631,   636,
   643,   652,   654,   657,   661,   663,   666,   676,   678,   682,
   685,   689,   697,   699,   703,   708,   711,   718,   720,   727,
   734,   748,   750,   753,   758,   766,   774,   784,   786,   790,
   797,   802,   805,   809,   811,   815,   831,   838,   851,   854,
   856,   862,   865,   869,   871,   879,   884,   886,   890,   893,
   897,   900,   907,   923,   925,   926,   927,   928,   929,   930,
   931,   932,   937,   945,   953,   958,   961,   963,   965,   967,
   969,   971,   978,   981,   983,   987,   992,   994,   998,  1001,
  1004,  1007,  1014,  1017,  1019,  1021,  1024,  1027,  1031,  1033,
  1037,  1039,  1043,  1046,  1052,  1057,  1059,  1062,  1065,  1069,
  1071,  1080,  1083,  1085,  1087,  1092,  1094,  1101,  1104,  1107,
  1109,  1113,  1117,  1120,  1124,  1129,  1136,  1139,  1143,  1145,
  1156,  1159,  1162,  1164,  1167,  1169,  1171,  1173,  1175,  1177,
  1178,  1180,  1187,  1189,  1192,  1198,  1203,  1205,  1206,  1207,
  1208,  1209,  1210,  1211,  1212,  1213,  1214,  1215,  1216,  1217,
  1218,  1219,  1220,  1221,  1222,  1223,  1224,  1225,  1226,  1227,
  1228,  1229,  1230,  1231,  1232,  1233,  1234,  1235,  1240,  1243,
  1247,  1254,  1258,  1260,  1262,  1264,  1271,  1274,  1278,  1280,
  1284,  1287,  1294,  1297,  1299,  1303,  1306,  1310,  1313,  1317,
  1320,  1324,  1326,  1330,  1333,  1335,  1337,  1344,  1346,  1347,
  1350,  1355,  1363,  1365,  1366,  1368,  1370,  1371,  1372,  1375,
  1380,  1385,  1387,  1389,  1391,  1394,  1397,  1407,  1411,  1413,
  1416,  1418,  1421,  1426,  1428,  1431,  1438,  1440,  1444,  1446,
  1447,  1449,  1451,  1453,  1455,  1457,  1459,  1461,  1463,  1465,
  1467,  1469,  1471,  1473,  1476,  1478,  1480,  1482,  1484,  1486,
  1488,  1490,  1492,  1499,  1502,  1504,  1506,  1508,  1510,  1512,
  1514,  1516,  1518,  1520,  1522,  1529,  1533,  1540,  1546,  1551,
  1556,  1561,  1564,  1568,  1573
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","ABSTRACT",
"BOOLEAN","BREAK","BROADCAST","BYTE","CASE","CATCH","CHAR","CLASS","CONTINUE",
"DEFAULT","DO","DOUBLE","DOMAIN","ELSE","EXTENDS","FINAL","FINALLY","FLOAT",
"FOR","FROM","FOREACH","IF","IMPLEMENTS","IMPORT","INSTANCEOF","INT","INTERFACE",
"IMMUTABLE","IN","INLINE","LOCAL","LONG","NATIVE","NEW","_NULL","OPERATOR","OVERLAP",
"_PACKAGE","PRIVATE","PROTECTED","PUBLIC","PARTITION","POINT","RECTDOMAIN","RETURN",
"SHORT","STATIC","SUPER","SWITCH","SYNCHRONIZED","SINGLE","SGLOBAL","THIS","THROW",
"THROWS","TRANSIENT","TRY","VOID","VOLATILE","WHILE","TRUE","FALSE","IDENTIFIER",
"INT_LITERAL","LONG_LITERAL","FLOAT_LITERAL","DOUBLE_LITERAL","DOUBLE_DIM","CHARACTER_LITERAL",
"STRING_LITERAL","'('","')'","'{'","'}'","'['","']'","','","'.'","';'","EMPTY_DIM",
"'='","'>'","'<'","'!'","'~'","'?'","':'","'+'","'-'","'*'","'/'","'&'","'|'",
"'^'","'%'","CAND","COR","EQ","NE","LE","GE","LSHIFTL","ASHIFTR","LSHIFTR","PLUS_ASG",
"MINUS_ASG","MULT_ASG","DIV_ASG","REM_ASG","LSHIFTL_ASG","ASHIFTR_ASG","LSHIFTR_ASG",
"AND_ASG","XOR_ASG","OR_ASG","PLUSPLUS","MINUSMINUS","GUARDS","Start","Literal",
"Type","QualifiedBaseType","BaseType","ComplexBaseType","ArraySpecifiers","ArraySpecifier",
"QualifiersOpt","Qualifiers","PrimitiveType","TitaniumType","CompilationUnit",
"PackageDeclarationOpt","ImportStatementsOpt","TypeDeclarationsOpt","TypeDeclaration",
"ImportStatement","TypeImportStatement","TypeImportOnDemandStatement","ClassDeclaration",
"ClassModifiersOpt","ClassModifiers","ClassModifier","SuperOpt","InterfacesOpt",
"ClassBody","FieldDeclarationsOpt","FieldDeclarations","FieldDeclaration","FieldVariableDeclaration",
"FieldModifiersOpt","FieldModifiers","FieldModifier","VariableDeclarators","VariableDeclarator",
"VariableInitializer","MethodDeclaration","MethodName","Void","OverlapsOpt",
"OverlapDecl","ParameterListOpt","ParameterList","Parameter","ThrowsOpt","Throws",
"TypeNameList","MethodBody","ConstructorDeclaration","ConstructorCallStatement",
"ExplicitThisConstructorCallStatement","ExplicitSuperConstructorCallStatement",
"StaticInitializer","InterfaceDeclaration","ExtendsInterfacesOpt","ExtendsInterfaces",
"InterfaceBody","InterfaceMemberDeclarationsOpt","InterfaceMemberDeclaration",
"ConstantFieldDeclaration","MethodSignatureDeclaration","ArrayInitializer","ElementInitializers",
"Element","Block","BlockStatementsOpt","BlockStatements","BlockStatement","LocalVariableDeclarationStatement",
"Statement","EmptyStatement","LabeledStatement","ExpressionStatement","StatementExpression",
"SelectionStatement","SwitchBlock","SwitchBlockStatementsOpt","SwitchLabels",
"SwitchLabel","IterationStatement","ForInit","ForUpdateOpt","StatementExpressionsOpt",
"StatementExpressions","ForEachStatement","OptionalInline","ForEachClauses",
"SpecialIn","JumpStatement","LabelOpt","GuardingStatement","TryBlock","Catches",
"Catch","Finally","PartitionStatement","PartitionClauses","PrimaryExpression",
"NotJustName","ComplexPrimary","Name","SimpleName","QualifiedName","OperatorName",
"ArrayAccess","IndexExpression","FieldAccess","MethodCall","ArgumentListOpt",
"ArgumentList","AllocationExpression","RegionOpt","DimExprs","DimExpr","DimsOpt",
"Dims","PostfixExpression","PostIncrement","PostDecrement","UnaryExpression",
"PreIncrement","PreDecrement","RestrictedUnaryExpression","CastExpression","PointLiteral",
"DomainLiteral","DomainPairs","DomainPair","DomainTriples","DomainTriple","ExpressionOpt",
"Expression","Expression1","Assignment","ConstantExpression","BroadcastExpression",
"empty", NULL
};
#endif

static const short yyr1[] = {     0,
   122,   123,   123,   123,   123,   123,   123,   123,   123,   124,
   124,   125,   126,   126,   126,   127,   127,   128,   128,   129,
   129,   130,   130,   131,   131,   131,   131,   132,   132,   132,
   132,   132,   132,   132,   132,   133,   133,   133,   134,   135,
   135,   136,   136,   137,   137,   137,   138,   138,   139,   139,
   140,   141,   142,   143,   143,   144,   144,   145,   145,   145,
   145,   146,   146,   147,   147,   148,   149,   149,   150,   150,
   151,   151,   151,   151,   152,   153,   153,   154,   154,   155,
   155,   155,   155,   155,   155,   155,   155,   155,   155,   155,
   155,   155,   155,   156,   156,   157,   157,   158,   158,   159,
   159,   160,   160,   161,   162,   162,   163,   164,   164,   165,
   165,   166,   167,   167,   168,   169,   169,   170,   170,   171,
   171,   172,   172,   173,   174,   175,   176,   177,   177,   178,
   179,   180,   180,   181,   181,   182,   183,   183,   184,   184,
   184,   185,   185,   186,   186,   187,   188,   188,   189,   189,
   190,   190,   191,   192,   192,   192,   192,   192,   192,   192,
   192,   192,   193,   194,   195,   196,   196,   196,   196,   196,
   196,   196,   197,   197,   197,   198,   199,   199,   200,   200,
   201,   201,   202,   202,   202,   202,   203,   203,   204,   204,
   205,   205,   206,   206,   207,   208,   208,   209,   209,   210,
   210,   211,   211,   211,   211,   212,   212,   213,   213,   213,
   213,   214,   215,   215,   216,   217,   218,   218,   219,   219,
   220,   220,   221,   221,   222,   222,   222,   222,   222,   222,
   222,   222,   223,   223,   224,   225,   226,   226,   226,   226,
   226,   226,   226,   226,   226,   226,   226,   226,   226,   226,
   226,   226,   226,   226,   226,   226,   226,   226,   226,   226,
   226,   226,   226,   226,   226,   226,   226,   226,   227,   227,
   228,   229,   229,   229,   229,   229,   230,   230,   231,   231,
   232,   232,   233,   233,   233,   234,   234,   235,   235,   236,
   236,   237,   237,   238,   238,   238,   238,   239,   239,   239,
   240,   241,   242,   242,   242,   242,   242,   242,   242,   243,
   244,   245,   245,   245,   245,   246,   246,   247,   248,   248,
   249,   249,   250,   251,   251,   252,   253,   253,   254,   254,
   254,   254,   254,   254,   254,   254,   254,   254,   254,   254,
   254,   254,   254,   254,   255,   255,   255,   255,   255,   255,
   255,   255,   255,   256,   256,   256,   256,   256,   256,   256,
   256,   256,   256,   256,   256,   257,   258,   259,   139,   135,
   187,   192,   192,   151,   138
};

static const short yyr2[] = {     0,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     2,     2,     1,     1,     1,     1,     1,     1,     2,     2,
     2,     1,     1,     1,     1,     2,     2,     1,     1,     1,
     1,     1,     1,     1,     1,     4,     4,     4,     3,     3,
     1,     1,     2,     1,     2,     2,     1,     1,     1,     1,
     3,     5,     6,     1,     1,     1,     2,     1,     1,     1,
     1,     2,     1,     2,     1,     3,     1,     1,     1,     2,
     1,     1,     1,     1,     4,     1,     1,     1,     2,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     3,     2,     4,     1,     1,    10,
    10,     1,     1,     1,     0,     2,     6,     1,     1,     1,
     3,     3,     1,     1,     2,     1,     3,     1,     1,    10,
     9,     1,     1,     5,     5,     2,     5,     1,     1,     2,
     3,     1,     2,     1,     1,     4,     9,     9,     3,     4,
     2,     1,     3,     1,     1,     3,     1,     1,     1,     2,
     1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     2,     1,     1,     1,     1,     1,
     1,     1,     5,     7,     5,     3,     1,     3,     1,     2,
     3,     2,     5,     7,     8,     1,     2,     1,     1,     1,
     1,     1,     1,     3,     6,     1,     0,     3,     5,     1,
     1,     3,     3,     3,     3,     1,     1,     5,     2,     2,
     3,     2,     1,     2,     5,     2,     4,     5,     1,     4,
     1,     1,     1,     1,     1,     1,     1,     3,     3,     1,
     1,     1,     1,     1,     1,     3,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     3,     4,     4,
     1,     3,     3,     3,     3,     1,     4,     4,     1,     1,
     1,     3,     6,     4,     5,     3,     0,     1,     2,     4,
     2,     1,     1,     1,     2,     2,     3,     1,     1,     1,
     2,     2,     1,     1,     2,     2,     1,     1,     1,     2,
     2,     1,     2,     2,     1,     4,     4,     3,     3,     3,
     1,     3,     3,     1,     3,     5,     1,     1,     1,     1,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     5,     1,     1,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     1,     4,     0,     3,     3,
     3,     2,     2,     2,     2
};

static const short yydefact[] = {   368,
     0,     1,   368,    41,     0,   235,     0,   233,   234,     0,
     0,   368,    49,    50,    42,   370,     0,    40,     0,     0,
     0,    58,    59,    61,    60,     0,    39,     0,    47,     0,
    54,    56,    48,    55,    43,   236,   369,     0,    51,     0,
   375,    46,    45,     0,     0,    57,     0,     0,    87,    84,
    93,    92,    88,    82,    81,    80,    83,    89,    85,    86,
    90,    91,     0,    67,     0,    71,     0,    76,    78,    72,
    73,    74,    77,   368,   368,    52,   374,     0,   126,    66,
    70,    77,    28,    30,    29,    35,     0,    33,    32,    34,
     0,     0,    31,   104,     0,    10,   368,    13,    15,     0,
    14,   233,    83,    79,     0,   368,    63,     0,     0,   128,
   129,     0,   368,   368,     0,     0,     0,     0,   287,   226,
     0,     0,   368,     0,     0,     0,   227,     0,     0,     0,
     6,     7,     2,     3,     4,     5,     8,     9,     0,     0,
   163,     0,     0,     0,     0,     0,     0,   225,     0,     0,
    13,    15,   161,     0,     0,   149,   151,   152,   154,   155,
   156,     0,   157,   158,   186,   159,   160,     0,   162,   298,
   222,   224,   221,   233,   276,   230,   231,   232,   223,   312,
   299,   300,     0,   303,   304,   309,   315,   307,   308,   166,
   148,     0,     0,     0,     0,    94,     0,   368,   103,   368,
   368,    11,    18,    25,    24,    12,    22,    23,     0,   102,
   368,    62,     0,     0,    65,   116,   130,   368,   127,   371,
   372,   373,     0,   206,   207,     0,     0,    16,    17,     0,
   221,   368,     0,     0,     0,     0,   267,   240,   239,   237,
   238,   245,   246,   247,   248,   249,   250,   251,   252,   243,
   244,   241,   242,   253,   254,   255,   256,   257,   258,   259,
   260,   261,   262,   263,   264,   265,   266,   368,     0,     0,
   232,   223,   299,   300,   345,   303,   304,     0,   327,   329,
   344,   330,   328,     0,     0,     0,     0,   212,     0,     0,
   221,     0,     0,     0,   321,     0,   324,   281,   314,   313,
   305,   306,   310,   311,     0,   368,     0,   146,   150,   165,
     0,     0,   210,   213,   209,     0,     0,   368,     0,     0,
     0,   368,   301,   302,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   345,     0,     0,     0,
     0,    75,   368,   294,    96,   292,   293,    21,    20,    19,
    27,    26,   368,     0,     0,   108,   110,   109,    64,    53,
     0,     0,     0,   368,   134,   135,    77,   202,   203,     0,
   188,   193,   368,     0,   191,   192,     0,     0,     0,     0,
     0,   368,   268,     0,     0,   219,   368,     0,   204,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   273,     0,     0,   205,     0,     0,   229,   228,   318,   319,
     0,   320,     0,     0,     0,   153,   274,     0,   216,   211,
   214,   272,     0,   271,   281,     0,   279,   280,     0,   275,
   164,     0,   354,   358,   359,   355,   356,   357,   360,   362,
   361,   363,   364,   365,    38,    36,    37,    95,     0,   295,
     0,   296,     0,   368,   368,     0,   117,     0,     0,   131,
   133,     0,     0,     0,   187,   197,   200,   201,     0,     0,
   286,     0,   284,   288,   368,   368,   217,     0,     0,     0,
   335,   332,   331,     0,   338,   339,   340,   341,   342,   336,
   337,   333,   334,   349,   350,   346,   347,   348,   351,   353,
   352,     0,     0,     0,   316,   317,   322,     0,   325,     0,
   282,   323,     0,   270,   278,   269,   277,   368,     0,    97,
    99,    98,   297,   368,   112,     0,     0,   113,   114,   111,
     0,     0,     0,     0,   194,   368,   196,     0,   198,   173,
     0,   285,   289,   291,     0,   368,   218,   367,     0,   368,
   175,   208,   183,     0,     0,     0,     0,   368,   141,   145,
     0,   142,   144,   368,   115,     0,   136,   368,   368,     0,
     0,   189,   190,   195,     0,     0,   368,   283,   220,   343,
     0,     0,     0,     0,   179,   177,   323,     0,   326,   215,
   105,   139,     0,   105,     0,   227,     0,   122,   123,     0,
     0,     0,   184,     0,   199,   174,   290,   366,     0,   182,
   176,     0,   180,     0,     0,   105,   140,   143,     0,   368,
   368,     0,   121,   368,   368,   185,   181,   178,     0,   119,
   100,   118,   106,   101,     0,     0,   120,   368,   368,     0,
     0,     0,     0,     0,     0,   125,   124,   137,   138,     0,
   107,     0,     0,     0
};

static const short yydefgoto[] = {   662,
   148,   149,    96,    97,   150,   202,   203,   206,   207,   228,
   229,     2,     3,    11,    27,    28,    12,    13,    14,    29,
    30,    31,    32,   106,   214,    41,    63,    64,    65,    66,
    67,    68,    69,   195,   196,   530,    70,   197,   100,   625,
   626,   355,   356,   357,   537,   538,   217,   641,    71,   607,
   608,   609,    72,    33,   109,   110,   219,   363,   364,   365,
   366,   570,   571,   572,   153,   154,   155,   156,   157,   158,
   159,   160,   161,   162,   163,   561,   593,   594,   595,   164,
   373,   581,   374,   375,   165,   548,   377,   479,   166,   223,
   167,   168,   313,   314,   315,   169,   384,   170,   171,   172,
   231,     8,     9,   175,   176,   433,   177,   271,   436,   437,
   272,   236,   483,   484,   345,   346,   180,   273,   274,   275,
   276,   277,   186,   187,   188,   189,   294,   295,   296,   297,
   278,   435,   280,   281,   619,   282,   347
};

static const short yypact[] = {    51,
    24,-32768,    93,-32768,   -32,-32768,    23,-32768,-32768,    30,
   125,    93,-32768,-32768,-32768,-32768,    63,-32768,    59,    70,
    73,-32768,-32768,-32768,-32768,   125,-32768,   125,-32768,    42,
    33,-32768,-32768,   153,-32768,-32768,-32768,   -31,-32768,  2321,
-32768,-32768,-32768,    96,    96,-32768,   111,   114,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   102,-32768,-32768,-32768,
-32768,-32768,    88,-32768,  2385,-32768,  2688,  2729,-32768,-32768,
-32768,-32768,    98,   195,   198,-32768,-32768,  1496,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   136,-32768,-32768,-32768,
   143,   147,-32768,-32768,     3,   -22,    25,-32768,-32768,     3,
   138,   171,-32768,-32768,  2712,   225,-32768,  2712,   182,-32768,
-32768,    11,    96,    96,  1852,   187,   193,   206,   208,-32768,
  2707,    19,  2089,   178,   216,   220,-32768,  2089,   102,   227,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2089,  2089,
-32768,  2168,  2168,  2168,  2168,  2168,  2168,-32768,    96,   188,
   189,   221,-32768,   226,  1585,-32768,-32768,-32768,-32768,-32768,
-32768,   222,-32768,-32768,-32768,-32768,-32768,    35,-32768,   238,
-32768,   242,   663,   236,-32768,-32768,   260,    60,    99,    83,
   130,   172,   977,   196,   209,-32768,-32768,-32768,-32768,-32768,
-32768,  2168,  2168,  2168,     9,-32768,   261,   -16,-32768,    25,
    25,-32768,   -22,   282,   303,-32768,-32768,-32768,   264,-32768,
  2712,-32768,  2712,    73,-32768,   259,-32768,  2729,-32768,-32768,
-32768,-32768,   262,-32768,-32768,   266,    85,-32768,-32768,   278,
    37,  2168,    96,  2089,  2089,  2712,   258,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,  2089,   270,  2089,
-32768,-32768,-32768,-32768,   977,-32768,-32768,   267,  1056,    40,
-32768,-32768,-32768,     3,  2089,  2089,  1099,-32768,  2089,   275,
   685,  1267,   272,   273,   276,   279,   280,   954,-32768,-32768,
-32768,-32768,-32768,-32768,    21,   271,     3,-32768,-32768,-32768,
   281,   102,   339,   353,-32768,     3,  2089,  2089,  2089,    18,
  1852,  2089,-32768,-32768,  2089,  2089,  2089,  2089,  2089,  2089,
  2089,  2089,  2089,  2089,  2089,  2089,-32768,    92,   181,   684,
    96,-32768,  2712,   329,   283,   285,-32768,-32768,-32768,-32768,
-32768,-32768,  2712,    96,   294,-32768,   291,-32768,-32768,-32768,
  2712,  2688,   295,  2729,-32768,-32768,   297,-32768,-32768,   301,
-32768,   296,  2089,   299,-32768,-32768,   309,     2,  2368,  2398,
   307,    12,-32768,   311,   723,-32768,  2089,   838,-32768,  2712,
  2089,  2089,  2089,  2089,  2089,  2089,  2089,  2089,  2089,  2089,
  2089,  2089,  2168,  2168,  2168,  2168,  2168,  2168,  2168,  2168,
-32768,  2421,  2451,-32768,  2481,  2168,  2247,-32768,-32768,-32768,
  2089,-32768,  2089,  2089,  2089,-32768,-32768,  2712,-32768,-32768,
-32768,-32768,   312,-32768,  1186,   315,-32768,-32768,   314,-32768,
-32768,   321,  1056,  1056,  1056,  1056,  1056,  1056,  1056,  1056,
  1056,  1056,  1056,  1056,-32768,-32768,-32768,-32768,   325,-32768,
  2010,   369,   334,   271,   328,  2712,-32768,     3,     3,-32768,
-32768,  2089,  2168,   322,-32768,   380,-32768,-32768,  2089,  1852,
-32768,  2089,   -22,   307,    25,  2089,-32768,  1852,   337,  2089,
-32768,-32768,-32768,  2501,   352,   435,   398,   605,   210,    -5,
    -5,-32768,-32768,   141,   141,-32768,-32768,-32768,   133,   133,
   133,   342,  1852,  1852,-32768,-32768,-32768,  2521,-32768,  2541,
-32768,  2561,   340,-32768,-32768,-32768,-32768,   271,  1263,-32768,
-32768,  1056,-32768,   271,-32768,  2712,   343,-32768,-32768,-32768,
    57,   346,   351,  2584,-32768,  2168,-32768,  1852,  2611,   410,
  1034,-32768,-32768,-32768,   354,  2089,-32768,  1056,  2089,   302,
-32768,-32768,-32768,  2089,  2089,  2089,   102,   328,-32768,-32768,
   -26,-32768,  1056,   328,-32768,  1674,-32768,  2712,  2712,   349,
   358,-32768,-32768,-32768,    96,  1852,    25,-32768,-32768,  1056,
  2089,   338,   359,  1852,   302,-32768,  1056,  2561,  1056,-32768,
   400,-32768,  1931,   400,    89,   371,  1763,-32768,-32768,   373,
   376,   383,-32768,  1852,-32768,-32768,-32768,  1056,   356,-32768,
-32768,  1407,-32768,   385,   100,   400,-32768,-32768,   100,  2089,
  2089,   384,-32768,   271,   271,-32768,-32768,-32768,    96,-32768,
-32768,-32768,-32768,-32768,   387,   389,-32768,   328,   328,   368,
   378,   390,   391,   396,    96,-32768,-32768,-32768,-32768,   404,
-32768,   487,   488,-32768
};

static const short yypgoto[] = {-32768,
-32768,    81,  -106,   -86,-32768,  -186,-32768,  -192,-32768,   -45,
    49,-32768,-32768,   478,    91,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,   461,-32768,-32768,   284,-32768,   429,-32768,-32768,
  -200,-32768,   428,  -145,   156,-32768,-32768,   -70,   145,  -556,
-32768,  -314,    39,    75,  -527,-32768,  -203,  -121,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   146,-32768,-32768,
-32768,    52,-32768,   -87,   -56,  -531,   -77,  -142,   287,   -91,
-32768,-32768,-32768,  -225,-32768,-32768,   -97,   -69,-32768,-32768,
-32768,-32768,-32768,  -446,-32768,-32768,   -58,-32768,-32768,   414,
-32768,-32768,   229,-32768,   228,-32768,  -367,-32768,-32768,-32768,
     4,   128,-32768,   -63,-32768,   232,-32768,   -72,  -306,  -125,
   292,-32768,    61,-32768,  -426,-32768,-32768,   374,   397,   185,
   403,   489,   127,-32768,-32768,  -360,   132,-32768,   131,-32768,
   175,   836,   274,   532,-32768,-32768,     0
};


#define	YYLAST		2825


static const short yytable[] = {     4,
    79,   216,    15,   305,     7,   178,   372,   348,   349,   359,
    34,    15,   309,    20,   293,   442,   350,   362,   212,   489,
   485,    98,   390,   230,     5,    34,   545,    34,   459,   209,
    19,   199,   151,   477,    36,    22,   199,   535,   463,    73,
   601,   121,   178,   311,   610,   204,   604,   629,   200,    16,
   602,    23,    44,   603,   312,   222,   121,  -102,   204,    98,
   201,    47,    98,    24,    82,   205,   344,   478,     6,   643,
   101,    45,   288,   107,   111,   632,    25,   191,   205,   391,
   392,   173,   178,    36,     6,   486,    78,   220,   341,     6,
   342,     1,   221,   151,   268,     6,   208,   401,   402,   582,
   341,   568,   426,    17,    18,   215,   216,   574,   101,   151,
   318,   101,   225,   225,   319,    99,    42,   320,    43,    10,
   653,   654,   283,   485,  -368,    21,   152,    22,    36,   381,
   403,   404,   405,   406,  -171,  -368,   341,   407,   577,  -171,
    37,  -171,   291,    23,   408,   409,   410,    95,    40,   382,
    38,    39,   -44,    99,  -368,    24,    99,   467,   173,   178,
    78,     6,   630,   362,    80,    98,   221,    98,    25,   284,
   222,    74,    75,  -172,   -68,    78,   455,    78,  -172,   555,
  -172,   640,   403,   404,   405,   406,   151,   152,   589,   407,
    98,   434,    76,   434,   102,    77,   408,   409,   410,   208,
   208,   323,   324,   152,  -169,   174,    26,   648,   649,  -169,
   358,  -169,   105,   411,   101,   108,   101,   367,    17,   290,
   199,   192,   198,   403,   404,   405,   406,   210,   193,   441,
   407,   376,   194,   405,   406,   173,   427,   390,   407,   101,
   224,   224,   174,   199,   211,   432,  -170,   372,   178,   269,
   213,  -170,   199,  -170,   216,   429,   440,   218,   284,    99,
   232,    99,   183,   611,   612,   456,   233,   386,   307,   -16,
  -167,   403,   404,   405,   406,  -167,   306,  -167,   407,   234,
   152,   235,   174,  -168,    99,   408,   409,   410,  -168,   285,
  -168,   354,   554,   286,   391,   392,   552,    98,   521,   183,
   289,   -17,   308,   310,   394,   395,   396,    98,   397,   591,
   399,   400,   401,   402,   592,    98,    98,   438,   316,   317,
   372,   438,   541,   645,   646,   321,   299,   300,   301,   302,
   303,   304,   575,   322,   343,   351,   352,   353,   361,   183,
   370,   383,   358,   368,    98,   387,   101,   369,   389,   416,
   419,   420,   358,   344,   428,   421,   101,   422,   312,   423,
   378,   311,   460,   367,   101,   101,   461,   462,   465,   179,
   466,   470,   283,  -132,   472,   473,   337,   337,   337,   390,
   475,   208,    98,   476,   482,   536,   386,   487,   550,   525,
   524,    99,   526,   101,   617,   527,   556,   542,   543,   528,
   178,    99,   533,   546,   199,   199,   179,   178,   534,    99,
    99,   210,   547,   557,   567,   178,   183,   560,   576,   578,
    98,   562,   563,   354,   579,   390,   586,   620,   588,   216,
   613,   101,   614,   354,   210,   621,   391,   392,    99,   624,
   178,   178,   468,   210,   631,   637,   179,   655,   174,   633,
   634,   181,   399,   400,   401,   402,   584,   635,   639,   656,
   647,   651,   390,   652,   539,   338,   339,   340,   306,   101,
   491,   657,   658,   178,   182,   178,    99,   659,   661,   309,
   184,   464,   391,   392,   208,   438,   663,   664,   181,    35,
    98,    46,   394,    81,   616,   104,   458,   360,   399,   400,
   401,   402,   523,   178,   540,   183,   469,   644,   354,   471,
   600,   182,   531,   178,    99,   628,   622,   184,   371,   391,
   392,   178,   636,   179,   638,   623,   615,   226,   181,   394,
   151,   396,    98,    98,   178,   399,   400,   401,   402,   101,
   430,   178,   431,   516,   553,   583,   354,   474,   151,   178,
   439,   182,   517,   519,     0,   386,     0,   184,     0,   596,
     0,   151,     0,     0,     0,     0,   185,   539,   642,     0,
     0,     0,   642,   539,     0,   191,   151,   358,   358,   173,
     0,   101,   101,     0,    99,     0,   208,   337,   337,   337,
   337,   337,   337,   337,   337,   198,   210,   173,     0,     0,
   515,     0,     0,   185,     0,   181,   191,   174,     0,   190,
   173,     0,   179,     0,     0,   174,     0,     0,     0,     0,
     0,   596,     0,     0,   152,   173,    99,    99,   182,   438,
   438,     0,   390,     0,   184,     0,     0,     0,     0,     0,
   174,   174,   152,   185,     0,     0,   190,   539,   539,     0,
     0,     0,     0,     0,     0,   152,     0,   183,   354,   354,
     0,     0,     0,     0,   183,     0,     0,     0,     0,     0,
   152,     0,   183,     0,     0,   174,   504,   505,   506,   507,
   508,   509,   510,   511,     0,     0,   190,     0,     0,   391,
   392,     0,     0,     0,   181,     0,   -14,   183,   183,   394,
   395,   396,     0,   174,     0,   399,   400,   401,   402,     0,
     0,     0,   378,   174,     0,     0,   -14,   182,   -14,     0,
   185,   174,     0,   184,     0,     0,     0,     0,   -14,     0,
   183,     0,   183,   -14,   174,     0,   318,     0,   -14,     0,
   319,   174,     0,   320,     0,   -14,     0,     0,     0,   174,
   390,     0,     0,     0,     0,   -14,     0,     0,   318,   417,
   183,     0,   319,   190,   179,   320,   650,   -14,   457,     0,
   183,   179,     0,     0,   403,   404,   405,   406,   183,   179,
     0,   407,   660,     0,     0,     0,     0,     0,   408,   409,
   410,   183,     0,     0,     0,     0,     0,     0,   183,     0,
     0,     0,     0,     0,   179,   179,   183,   391,   392,   185,
     0,   393,     0,     0,     0,     0,     0,   394,   395,   396,
     0,   397,   398,   399,   400,   401,   402,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   179,     0,   179,
     0,     0,     0,   488,     0,     0,   181,     0,     0,     0,
     0,     0,   190,   181,     0,     0,     0,     0,     0,     0,
   490,   181,     0,     0,     0,   390,     0,   179,     0,   182,
     0,     0,     0,     0,     0,   184,   182,   179,     0,     0,
     0,     0,   184,     0,   182,   179,   181,   181,     0,     0,
   184,     0,     0,     0,     0,     0,     0,     0,   179,     0,
     0,     0,     0,     0,     0,   179,     0,     0,     0,   182,
   182,     0,     0,   179,     0,   184,   184,     0,     0,   181,
     0,   181,   391,   392,     0,     0,   393,     0,     0,     0,
     0,     0,   394,   395,   396,     0,   397,   398,   399,   400,
   401,   402,   182,     0,   182,     0,     0,     0,   184,   181,
   184,     0,     0,     0,     0,     0,     0,     0,   279,   181,
     0,   185,     0,   287,     0,     0,     0,   181,   185,     0,
     0,     0,   182,     0,   292,   298,   185,     0,   184,     0,
   181,   390,   182,     0,     0,     0,     0,   181,   184,     0,
   182,     0,     0,     0,     0,   181,   184,     0,     0,     0,
     0,   185,   185,   182,   190,     0,     0,     0,     0,   184,
   182,   190,     0,     0,     0,     0,   184,     0,   182,   190,
     0,     0,     0,     0,   184,     0,     0,     0,     0,     0,
     0,     0,     0,   424,   185,     0,   185,     0,   391,   392,
     0,     0,   393,   425,   190,   190,     0,     0,   394,   395,
   396,     0,   397,   398,   399,   400,   401,   402,     0,     0,
   325,   390,     0,     0,   185,     0,     0,     0,     0,   379,
   380,     0,     0,     0,   185,     0,     0,   190,     0,   190,
     0,     0,   185,   390,   326,   327,   328,   329,   330,   331,
   332,   333,   334,   335,   336,   185,     0,     0,     0,     0,
     0,     0,   185,   385,     0,   388,     0,   190,     0,     0,
   185,     0,   587,     0,     0,     0,     0,   190,   391,   392,
   412,   413,   393,   425,   415,   190,   390,     0,   394,   395,
   396,     0,   397,   398,   399,   400,   401,   402,   190,     0,
   391,   392,     0,     0,   393,   190,     0,     0,     0,     0,
   394,   395,   396,   190,   397,   398,   399,   400,   401,   402,
   443,   444,   445,   446,   447,   448,   449,   450,   451,   452,
   453,   454,     0,     0,     0,     0,     0,     0,     0,     0,
   414,     0,     0,   391,   392,     0,     0,   393,     0,     0,
     0,     0,     0,   394,   395,   396,     0,   397,   398,   399,
   400,   401,   402,     0,     0,     0,     0,     0,   279,     0,
     0,     0,     0,   390,     0,     0,     0,     0,     0,     0,
     0,     0,   385,     0,     0,     0,   492,   493,   494,   495,
   496,   497,   498,   499,   500,   501,   502,   503,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,   518,     0,   520,     0,
   522,     0,     0,     0,     0,   424,    83,     0,   270,    84,
   391,   392,    85,     0,   393,     0,     0,    86,    87,     0,
   394,   395,   396,    88,   397,   398,   399,   400,   401,   402,
     0,    89,     0,     0,   390,     0,   532,    90,     0,   119,
   120,   121,     0,     0,     0,     0,     0,   544,    91,    92,
     0,    93,     0,   124,   549,     0,     0,   551,   127,     0,
     0,     0,     0,     0,     0,   558,   131,   132,     6,   133,
   134,   135,   136,     0,   137,   138,   139,     0,   529,   569,
   140,   418,     0,     0,     0,     0,     0,     0,     0,   142,
   143,   391,   392,   144,   145,   393,     0,     0,     0,     0,
     0,   394,   395,   396,   573,   397,   398,   399,   400,   401,
   402,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   146,   147,     0,     0,     0,     0,     0,     0,     0,
     0,   385,     0,     0,   590,     0,     0,     0,     0,   597,
   598,   599,     0,     0,     0,     0,     0,   227,     0,     0,
    83,   113,     0,    84,   591,     0,    85,     0,   114,   592,
   115,    86,    87,     0,     0,     0,   618,    88,   116,     0,
   117,   118,     0,     0,     0,    89,     0,     0,   573,     0,
     0,    90,     0,   119,   120,   121,     0,     0,     0,     0,
     0,   122,    91,    92,   123,    93,     0,   124,   125,   126,
     0,     0,   127,   128,     0,     0,   129,     0,     0,   130,
   131,   132,     6,   133,   134,   135,   136,     0,   137,   138,
   139,     0,    78,  -368,   140,     0,     0,     0,   141,     0,
     0,     0,     0,   142,   143,     0,   112,   144,   145,    83,
   113,     0,    84,     0,     0,    85,     0,   114,     0,   115,
    86,    87,     0,     0,     0,     0,    88,   116,     0,   117,
   118,     0,     0,     0,    89,   146,   147,     0,     0,     0,
    90,     0,   119,   120,   121,     0,     0,     0,     0,     0,
   122,    91,    92,   123,    93,     0,   124,   125,   126,     0,
     0,   127,   128,     0,     0,   129,     0,     0,   130,   131,
   132,     6,   133,   134,   135,   136,     0,   137,   138,   139,
     0,    78,  -368,   140,     0,     0,     0,   141,     0,     0,
     0,     0,   142,   143,     0,   227,   144,   145,    83,   113,
     0,    84,     0,     0,    85,     0,   114,     0,   115,    86,
    87,     0,     0,     0,     0,    88,   116,     0,   117,   118,
     0,     0,     0,    89,   146,   147,     0,     0,     0,    90,
     0,   119,   120,   121,     0,     0,     0,     0,     0,   122,
    91,    92,   123,    93,     0,   124,   125,   126,     0,     0,
   127,   128,     0,     0,   129,     0,     0,   130,   131,   132,
     6,   133,   134,   135,   136,     0,   137,   138,   139,     0,
    78,  -147,   140,     0,     0,     0,   141,     0,     0,     0,
     0,   142,   143,     0,   227,   144,   145,    83,   113,     0,
    84,     0,     0,    85,     0,   114,     0,   115,    86,    87,
     0,     0,     0,     0,    88,   116,     0,   117,   118,     0,
     0,     0,    89,   146,   147,     0,     0,     0,    90,     0,
   119,   120,   121,     0,     0,     0,     0,     0,   122,    91,
    92,   123,    93,     0,   605,   125,   126,     0,     0,   606,
   128,     0,     0,   129,     0,     0,   130,   131,   132,     6,
   133,   134,   135,   136,     0,   137,   138,   139,     0,    78,
  -368,   140,     0,     0,     0,   141,     0,     0,     0,     0,
   142,   143,     0,   227,   144,   145,    83,   113,     0,    84,
     0,     0,    85,     0,   114,     0,   115,    86,    87,     0,
     0,     0,     0,    88,   116,     0,   117,   118,     0,     0,
     0,    89,   146,   147,     0,     0,     0,    90,     0,   119,
   120,   121,     0,     0,     0,     0,     0,   122,    91,    92,
   123,    93,     0,   124,   125,   126,     0,     0,   127,   128,
     0,     0,   129,     0,     0,   130,   131,   132,     6,   133,
   134,   135,   136,     0,   137,   138,   139,     0,    78,  -368,
   140,     0,     0,     0,   141,     0,     0,     0,     0,   142,
   143,     0,   227,   144,   145,    83,   113,     0,    84,     0,
     0,    85,     0,   114,     0,   115,    86,    87,     0,     0,
     0,     0,    88,   116,     0,   117,   118,     0,     0,     0,
    89,   146,   147,     0,     0,     0,    90,     0,   119,   120,
   121,     0,     0,     0,     0,     0,   122,    91,    92,   123,
    93,     0,   124,   125,   126,     0,     0,   127,   128,     0,
     0,   129,     0,     0,   130,   131,   132,     6,   133,   134,
   135,   136,     0,   137,   138,   139,     0,    78,     0,   140,
     0,     0,     0,   141,    83,     0,   270,    84,   142,   143,
    85,     0,   144,   145,     0,    86,    87,     0,     0,     0,
     0,    88,     0,     0,     0,     0,     0,     0,     0,    89,
     0,     0,     0,     0,     0,    90,     0,   119,   120,   121,
   146,   147,     0,     0,     0,     0,    91,    92,     0,    93,
     0,   124,     0,     0,     0,     0,   127,     0,     0,     0,
     0,     0,     0,     0,   131,   132,     6,   133,   134,   135,
   136,     0,   137,   138,   139,     0,   529,   627,   140,     0,
     0,     0,     0,    83,     0,   270,    84,   142,   143,    85,
     0,   144,   145,     0,    86,    87,     0,     0,     0,     0,
    88,     0,     0,     0,     0,     0,     0,     0,    89,     0,
     0,     0,     0,     0,    90,     0,   119,   120,   121,   146,
   147,     0,     0,     0,     0,    91,    92,     0,    93,     0,
   124,     0,     0,     0,     0,   127,     0,     0,     0,     0,
     0,     0,     0,   131,   132,     6,   133,   134,   135,   136,
     0,   137,   138,   139,     0,   529,     0,   140,     0,     0,
     0,     0,    83,     0,   270,    84,   142,   143,    85,     0,
   144,   145,     0,    86,    87,     0,     0,     0,     0,    88,
     0,     0,     0,     0,     0,     0,     0,    89,     0,     0,
     0,     0,     0,    90,     0,   119,   120,   121,   146,   147,
     0,     0,     0,     0,    91,    92,     0,    93,     0,   124,
     0,     0,     0,     0,   127,     0,     0,     0,     0,     0,
     0,     0,   131,   132,     6,   133,   134,   135,   136,     0,
   137,   138,   139,     0,     0,     0,   140,     0,     0,     0,
     0,    83,     0,     0,    84,   142,   143,    85,     0,   144,
   145,     0,    86,    87,     0,     0,     0,     0,    88,     0,
     0,     0,     0,     0,     0,     0,    89,     0,     0,     0,
     0,     0,    90,     0,   119,   120,   121,   146,   147,     0,
     0,     0,     0,    91,    92,     0,    93,     0,   124,     0,
     0,     0,     0,   127,     0,     0,     0,     0,     0,     0,
     0,   131,   132,     6,   133,   134,   135,   136,     0,   137,
   138,   139,     0,     0,     0,   140,     0,     0,     0,     0,
    83,     0,     0,    84,   142,   143,    85,     0,   144,   145,
     0,    86,    87,     0,     0,     0,     0,    88,     0,     0,
     0,     0,     0,     0,     0,    89,     0,     0,     0,     0,
     0,    90,     0,   119,   120,   121,   146,   147,     0,     0,
     0,     0,    91,    92,     0,    93,     0,   124,     0,     0,
     0,     0,   127,     0,     0,     0,     0,     0,     0,     0,
   131,   132,     6,   133,   134,   135,   136,     0,   137,   138,
   139,    48,     0,    49,  -368,     0,     0,  -368,     0,     0,
  -368,     0,     0,   142,   143,  -368,  -368,     0,     0,    50,
     0,  -368,     0,     0,     0,     0,     0,     0,     0,  -368,
     0,     0,     0,    51,    52,  -368,    53,     0,     0,     0,
     0,     0,    54,    55,    56,     0,  -368,  -368,     0,  -368,
    57,     0,     0,    58,    59,    60,     0,     0,     0,    61,
     0,  -368,    62,     0,     0,    48,  -368,    49,  -368,     0,
     0,  -368,     0,     0,  -368,   390,     0,  -368,     0,  -368,
  -368,     0,     0,    50,     0,  -368,     0,     0,     0,     0,
     0,     0,     0,  -368,     0,     0,     0,    51,    52,  -368,
    53,     0,     0,     0,     0,   390,    54,    55,    56,     0,
  -368,  -368,     0,  -368,    57,     0,     0,    58,    59,    60,
     0,     0,   480,    61,     0,  -368,    62,     0,   390,     0,
  -368,     0,   391,   392,     0,     0,   393,     0,     0,     0,
     0,   -69,   394,   395,   396,     0,   397,   398,   399,   400,
   401,   402,   481,     0,     0,     0,     0,     0,   390,     0,
     0,     0,   391,   392,     0,     0,   393,     0,     0,     0,
     0,     0,   394,   395,   396,   512,   397,   398,   399,   400,
   401,   402,     0,     0,     0,   391,   392,     0,   390,   393,
     0,     0,     0,     0,     0,   394,   395,   396,     0,   397,
   398,   399,   400,   401,   402,   513,     0,     0,   390,     0,
     0,     0,     0,     0,     0,   391,   392,     0,     0,   393,
     0,     0,     0,     0,     0,   394,   395,   396,   390,   397,
   398,   399,   400,   401,   402,   514,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   391,   392,     0,   390,   393,
     0,     0,     0,     0,     0,   394,   395,   396,     0,   397,
   398,   399,   400,   401,   402,   391,   392,     0,   390,   393,
   559,     0,     0,     0,     0,   394,   395,   396,     0,   397,
   398,   399,   400,   401,   402,   391,   392,     0,     0,   393,
   564,   390,     0,     0,     0,   394,   395,   396,     0,   397,
   398,   399,   400,   401,   402,   391,   392,     0,     0,   393,
   565,     0,     0,     0,     0,   394,   395,   396,   390,   397,
   398,   399,   400,   401,   402,   391,   392,     0,     0,   393,
   566,     0,     0,     0,     0,   394,   395,   396,   580,   397,
   398,   399,   400,   401,   402,     0,     0,     0,   391,   392,
     0,     0,   393,     0,     0,     0,     0,     0,   394,   395,
   396,     0,   397,   398,   399,   400,   401,   402,     0,     0,
   585,    83,     0,     0,    84,   391,   392,    85,     0,   393,
     0,     0,    86,    87,     0,   394,   395,   396,    88,   397,
   398,   399,   400,   401,   402,    83,    89,     0,    84,     0,
     0,    85,    90,     0,     0,     0,    86,    87,     0,     0,
     0,    49,    88,    91,    92,     0,    93,     0,     0,     0,
    89,     0,     0,     0,     0,     0,    90,    50,    94,     0,
     0,     0,     0,     6,     0,     0,     0,    91,    92,     0,
    93,    51,    52,     0,    53,     0,     0,     0,     0,     0,
    54,    55,    56,     0,     0,     0,     0,     6,   103,     0,
     0,    58,    59,    60,     0,     0,     0,    61,     0,   237,
    62,   238,   239,   240,   241,     0,     0,   242,   243,   244,
   245,   246,   247,   248,   249,     0,     0,   250,   251,   252,
   253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
   263,   264,   265,   266,   267
};

static const short yycheck[] = {     0,
    57,   108,     3,   149,     1,    78,   232,   200,   201,   213,
    11,    12,   155,    10,   140,   322,   203,   218,   105,   387,
   381,    67,    28,   115,     1,    26,   473,    28,   343,   100,
     1,    95,    78,    32,    66,     3,   100,   464,   353,    40,
   568,    39,   115,     9,   576,    34,   574,   604,    71,    82,
    77,    19,    11,    80,    20,   112,    39,    74,    34,   105,
    83,    93,   108,    31,    65,    54,    83,    66,    66,   626,
    67,    30,   129,    74,    75,   607,    44,    78,    54,    85,
    86,    78,   155,    66,    66,    74,    76,    77,    80,    66,
    82,    41,    82,   139,    76,    66,    97,   103,   104,   546,
    80,   528,    82,    81,    82,   106,   213,   534,   105,   155,
    74,   108,   113,   114,    78,    67,    26,    81,    28,    27,
   648,   649,   123,   484,     0,     1,    78,     3,    66,   236,
    91,    92,    93,    94,    75,    11,    80,    98,    82,    80,
    82,    82,   139,    19,   105,   106,   107,    67,    76,   236,
    81,    82,     0,   105,    30,    31,   108,   361,   155,   232,
    76,    66,    74,   364,    77,   211,    82,   213,    44,    81,
   227,    44,    45,    75,    77,    76,    85,    76,    80,   486,
    82,    82,    91,    92,    93,    94,   232,   139,   556,    98,
   236,   317,    82,   319,    67,    82,   105,   106,   107,   200,
   201,   119,   120,   155,    75,    78,    82,   634,   635,    80,
   211,    82,    18,   284,   211,    18,   213,   218,    81,   139,
   284,    86,    95,    91,    92,    93,    94,   100,    86,   321,
    98,   232,    86,    93,    94,   232,   307,    28,    98,   236,
   113,   114,   115,   307,    74,   316,    75,   473,   321,   122,
    26,    80,   316,    82,   361,   312,   320,    76,    81,   211,
    74,   213,    78,   578,   579,    85,    74,   268,    81,    81,
    75,    91,    92,    93,    94,    80,   149,    82,    98,    74,
   232,    74,   155,    75,   236,   105,   106,   107,    80,    74,
    82,   211,   485,    74,    85,    86,   483,   343,   424,   115,
    74,    81,    77,    82,    95,    96,    97,   353,    99,     8,
   101,   102,   103,   104,    13,   361,   362,   318,    81,    78,
   546,   322,   468,   630,   631,    90,   142,   143,   144,   145,
   146,   147,   536,    74,    74,    54,    34,    74,    80,   155,
    63,    84,   343,    82,   390,    76,   343,    82,    82,    75,
    79,    79,   353,    83,    74,    80,   353,    79,    20,    80,
   233,     9,    34,   364,   361,   362,    84,    83,    75,    78,
    80,    77,   373,    77,    74,    80,   192,   193,   194,    28,
    82,   382,   428,    75,    78,    58,   387,    77,   480,    75,
    79,   343,    79,   390,   587,    75,   488,   468,   469,    75,
   473,   353,    34,    82,   468,   469,   115,   480,    75,   361,
   362,   284,    33,    77,    75,   488,   232,    76,    76,    74,
   466,   513,   514,   343,    74,    28,    17,    90,    75,   536,
    82,   428,    75,   353,   307,    77,    85,    86,   390,    40,
   513,   514,   362,   316,    74,    90,   155,    80,   321,    77,
    75,    78,   101,   102,   103,   104,   548,    75,    74,    82,
    77,    75,    28,    75,   465,   192,   193,   194,   341,   466,
   390,    82,    82,   546,    78,   548,   428,    82,    75,   622,
    78,   354,    85,    86,   485,   486,     0,     0,   115,    12,
   536,    31,    95,    65,   586,    68,   341,   214,   101,   102,
   103,   104,   428,   576,   466,   321,   362,   629,   428,   364,
   567,   115,   461,   586,   466,   603,   594,   115,   232,    85,
    86,   594,   614,   232,   622,   595,   585,   114,   155,    95,
   576,    97,   578,   579,   607,   101,   102,   103,   104,   536,
   313,   614,   314,   417,   484,   546,   466,   373,   594,   622,
   319,   155,   421,   423,    -1,   556,    -1,   155,    -1,   560,
    -1,   607,    -1,    -1,    -1,    -1,    78,   568,   625,    -1,
    -1,    -1,   629,   574,    -1,   576,   622,   578,   579,   576,
    -1,   578,   579,    -1,   536,    -1,   587,   403,   404,   405,
   406,   407,   408,   409,   410,   468,   469,   594,    -1,    -1,
   416,    -1,    -1,   115,    -1,   232,   607,   480,    -1,    78,
   607,    -1,   321,    -1,    -1,   488,    -1,    -1,    -1,    -1,
    -1,   622,    -1,    -1,   576,   622,   578,   579,   232,   630,
   631,    -1,    28,    -1,   232,    -1,    -1,    -1,    -1,    -1,
   513,   514,   594,   155,    -1,    -1,   115,   648,   649,    -1,
    -1,    -1,    -1,    -1,    -1,   607,    -1,   473,   578,   579,
    -1,    -1,    -1,    -1,   480,    -1,    -1,    -1,    -1,    -1,
   622,    -1,   488,    -1,    -1,   548,   403,   404,   405,   406,
   407,   408,   409,   410,    -1,    -1,   155,    -1,    -1,    85,
    86,    -1,    -1,    -1,   321,    -1,    34,   513,   514,    95,
    96,    97,    -1,   576,    -1,   101,   102,   103,   104,    -1,
    -1,    -1,   585,   586,    -1,    -1,    54,   321,    34,    -1,
   232,   594,    -1,   321,    -1,    -1,    -1,    -1,    66,    -1,
   546,    -1,   548,    71,   607,    -1,    74,    -1,    54,    -1,
    78,   614,    -1,    81,    -1,    83,    -1,    -1,    -1,   622,
    28,    -1,    -1,    -1,    -1,    71,    -1,    -1,    74,    75,
   576,    -1,    78,   232,   473,    81,   639,    83,    85,    -1,
   586,   480,    -1,    -1,    91,    92,    93,    94,   594,   488,
    -1,    98,   655,    -1,    -1,    -1,    -1,    -1,   105,   106,
   107,   607,    -1,    -1,    -1,    -1,    -1,    -1,   614,    -1,
    -1,    -1,    -1,    -1,   513,   514,   622,    85,    86,   321,
    -1,    89,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
    -1,    99,   100,   101,   102,   103,   104,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   546,    -1,   548,
    -1,    -1,    -1,   121,    -1,    -1,   473,    -1,    -1,    -1,
    -1,    -1,   321,   480,    -1,    -1,    -1,    -1,    -1,    -1,
    23,   488,    -1,    -1,    -1,    28,    -1,   576,    -1,   473,
    -1,    -1,    -1,    -1,    -1,   473,   480,   586,    -1,    -1,
    -1,    -1,   480,    -1,   488,   594,   513,   514,    -1,    -1,
   488,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   607,    -1,
    -1,    -1,    -1,    -1,    -1,   614,    -1,    -1,    -1,   513,
   514,    -1,    -1,   622,    -1,   513,   514,    -1,    -1,   546,
    -1,   548,    85,    86,    -1,    -1,    89,    -1,    -1,    -1,
    -1,    -1,    95,    96,    97,    -1,    99,   100,   101,   102,
   103,   104,   546,    -1,   548,    -1,    -1,    -1,   546,   576,
   548,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   123,   586,
    -1,   473,    -1,   128,    -1,    -1,    -1,   594,   480,    -1,
    -1,    -1,   576,    -1,   139,   140,   488,    -1,   576,    -1,
   607,    28,   586,    -1,    -1,    -1,    -1,   614,   586,    -1,
   594,    -1,    -1,    -1,    -1,   622,   594,    -1,    -1,    -1,
    -1,   513,   514,   607,   473,    -1,    -1,    -1,    -1,   607,
   614,   480,    -1,    -1,    -1,    -1,   614,    -1,   622,   488,
    -1,    -1,    -1,    -1,   622,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    80,   546,    -1,   548,    -1,    85,    86,
    -1,    -1,    89,    90,   513,   514,    -1,    -1,    95,    96,
    97,    -1,    99,   100,   101,   102,   103,   104,    -1,    -1,
    84,    28,    -1,    -1,   576,    -1,    -1,    -1,    -1,   234,
   235,    -1,    -1,    -1,   586,    -1,    -1,   546,    -1,   548,
    -1,    -1,   594,    28,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118,   607,    -1,    -1,    -1,    -1,
    -1,    -1,   614,   268,    -1,   270,    -1,   576,    -1,    -1,
   622,    -1,    79,    -1,    -1,    -1,    -1,   586,    85,    86,
   285,   286,    89,    90,   289,   594,    28,    -1,    95,    96,
    97,    -1,    99,   100,   101,   102,   103,   104,   607,    -1,
    85,    86,    -1,    -1,    89,   614,    -1,    -1,    -1,    -1,
    95,    96,    97,   622,    99,   100,   101,   102,   103,   104,
   325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
   335,   336,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    82,    -1,    -1,    85,    86,    -1,    -1,    89,    -1,    -1,
    -1,    -1,    -1,    95,    96,    97,    -1,    99,   100,   101,
   102,   103,   104,    -1,    -1,    -1,    -1,    -1,   373,    -1,
    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   387,    -1,    -1,    -1,   391,   392,   393,   394,
   395,   396,   397,   398,   399,   400,   401,   402,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   421,    -1,   423,    -1,
   425,    -1,    -1,    -1,    -1,    80,     4,    -1,     6,     7,
    85,    86,    10,    -1,    89,    -1,    -1,    15,    16,    -1,
    95,    96,    97,    21,    99,   100,   101,   102,   103,   104,
    -1,    29,    -1,    -1,    28,    -1,   461,    35,    -1,    37,
    38,    39,    -1,    -1,    -1,    -1,    -1,   472,    46,    47,
    -1,    49,    -1,    51,   479,    -1,    -1,   482,    56,    -1,
    -1,    -1,    -1,    -1,    -1,   490,    64,    65,    66,    67,
    68,    69,    70,    -1,    72,    73,    74,    -1,    76,    77,
    78,    75,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
    88,    85,    86,    91,    92,    89,    -1,    -1,    -1,    -1,
    -1,    95,    96,    97,   529,    99,   100,   101,   102,   103,
   104,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   119,   120,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   556,    -1,    -1,   559,    -1,    -1,    -1,    -1,   564,
   565,   566,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
     4,     5,    -1,     7,     8,    -1,    10,    -1,    12,    13,
    14,    15,    16,    -1,    -1,    -1,   591,    21,    22,    -1,
    24,    25,    -1,    -1,    -1,    29,    -1,    -1,   603,    -1,
    -1,    35,    -1,    37,    38,    39,    -1,    -1,    -1,    -1,
    -1,    45,    46,    47,    48,    49,    -1,    51,    52,    53,
    -1,    -1,    56,    57,    -1,    -1,    60,    -1,    -1,    63,
    64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
    74,    -1,    76,    77,    78,    -1,    -1,    -1,    82,    -1,
    -1,    -1,    -1,    87,    88,    -1,     1,    91,    92,     4,
     5,    -1,     7,    -1,    -1,    10,    -1,    12,    -1,    14,
    15,    16,    -1,    -1,    -1,    -1,    21,    22,    -1,    24,
    25,    -1,    -1,    -1,    29,   119,   120,    -1,    -1,    -1,
    35,    -1,    37,    38,    39,    -1,    -1,    -1,    -1,    -1,
    45,    46,    47,    48,    49,    -1,    51,    52,    53,    -1,
    -1,    56,    57,    -1,    -1,    60,    -1,    -1,    63,    64,
    65,    66,    67,    68,    69,    70,    -1,    72,    73,    74,
    -1,    76,    77,    78,    -1,    -1,    -1,    82,    -1,    -1,
    -1,    -1,    87,    88,    -1,     1,    91,    92,     4,     5,
    -1,     7,    -1,    -1,    10,    -1,    12,    -1,    14,    15,
    16,    -1,    -1,    -1,    -1,    21,    22,    -1,    24,    25,
    -1,    -1,    -1,    29,   119,   120,    -1,    -1,    -1,    35,
    -1,    37,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
    46,    47,    48,    49,    -1,    51,    52,    53,    -1,    -1,
    56,    57,    -1,    -1,    60,    -1,    -1,    63,    64,    65,
    66,    67,    68,    69,    70,    -1,    72,    73,    74,    -1,
    76,    77,    78,    -1,    -1,    -1,    82,    -1,    -1,    -1,
    -1,    87,    88,    -1,     1,    91,    92,     4,     5,    -1,
     7,    -1,    -1,    10,    -1,    12,    -1,    14,    15,    16,
    -1,    -1,    -1,    -1,    21,    22,    -1,    24,    25,    -1,
    -1,    -1,    29,   119,   120,    -1,    -1,    -1,    35,    -1,
    37,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,
    47,    48,    49,    -1,    51,    52,    53,    -1,    -1,    56,
    57,    -1,    -1,    60,    -1,    -1,    63,    64,    65,    66,
    67,    68,    69,    70,    -1,    72,    73,    74,    -1,    76,
    77,    78,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,
    87,    88,    -1,     1,    91,    92,     4,     5,    -1,     7,
    -1,    -1,    10,    -1,    12,    -1,    14,    15,    16,    -1,
    -1,    -1,    -1,    21,    22,    -1,    24,    25,    -1,    -1,
    -1,    29,   119,   120,    -1,    -1,    -1,    35,    -1,    37,
    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,
    48,    49,    -1,    51,    52,    53,    -1,    -1,    56,    57,
    -1,    -1,    60,    -1,    -1,    63,    64,    65,    66,    67,
    68,    69,    70,    -1,    72,    73,    74,    -1,    76,    77,
    78,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,    87,
    88,    -1,     1,    91,    92,     4,     5,    -1,     7,    -1,
    -1,    10,    -1,    12,    -1,    14,    15,    16,    -1,    -1,
    -1,    -1,    21,    22,    -1,    24,    25,    -1,    -1,    -1,
    29,   119,   120,    -1,    -1,    -1,    35,    -1,    37,    38,
    39,    -1,    -1,    -1,    -1,    -1,    45,    46,    47,    48,
    49,    -1,    51,    52,    53,    -1,    -1,    56,    57,    -1,
    -1,    60,    -1,    -1,    63,    64,    65,    66,    67,    68,
    69,    70,    -1,    72,    73,    74,    -1,    76,    -1,    78,
    -1,    -1,    -1,    82,     4,    -1,     6,     7,    87,    88,
    10,    -1,    91,    92,    -1,    15,    16,    -1,    -1,    -1,
    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,
    -1,    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    39,
   119,   120,    -1,    -1,    -1,    -1,    46,    47,    -1,    49,
    -1,    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,
    70,    -1,    72,    73,    74,    -1,    76,    77,    78,    -1,
    -1,    -1,    -1,     4,    -1,     6,     7,    87,    88,    10,
    -1,    91,    92,    -1,    15,    16,    -1,    -1,    -1,    -1,
    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,
    -1,    -1,    -1,    -1,    35,    -1,    37,    38,    39,   119,
   120,    -1,    -1,    -1,    -1,    46,    47,    -1,    49,    -1,
    51,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    64,    65,    66,    67,    68,    69,    70,
    -1,    72,    73,    74,    -1,    76,    -1,    78,    -1,    -1,
    -1,    -1,     4,    -1,     6,     7,    87,    88,    10,    -1,
    91,    92,    -1,    15,    16,    -1,    -1,    -1,    -1,    21,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,
    -1,    -1,    -1,    35,    -1,    37,    38,    39,   119,   120,
    -1,    -1,    -1,    -1,    46,    47,    -1,    49,    -1,    51,
    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    64,    65,    66,    67,    68,    69,    70,    -1,
    72,    73,    74,    -1,    -1,    -1,    78,    -1,    -1,    -1,
    -1,     4,    -1,    -1,     7,    87,    88,    10,    -1,    91,
    92,    -1,    15,    16,    -1,    -1,    -1,    -1,    21,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,
    -1,    -1,    35,    -1,    37,    38,    39,   119,   120,    -1,
    -1,    -1,    -1,    46,    47,    -1,    49,    -1,    51,    -1,
    -1,    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    64,    65,    66,    67,    68,    69,    70,    -1,    72,
    73,    74,    -1,    -1,    -1,    78,    -1,    -1,    -1,    -1,
     4,    -1,    -1,     7,    87,    88,    10,    -1,    91,    92,
    -1,    15,    16,    -1,    -1,    -1,    -1,    21,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    29,    -1,    -1,    -1,    -1,
    -1,    35,    -1,    37,    38,    39,   119,   120,    -1,    -1,
    -1,    -1,    46,    47,    -1,    49,    -1,    51,    -1,    -1,
    -1,    -1,    56,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    64,    65,    66,    67,    68,    69,    70,    -1,    72,    73,
    74,     1,    -1,     3,     4,    -1,    -1,     7,    -1,    -1,
    10,    -1,    -1,    87,    88,    15,    16,    -1,    -1,    19,
    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,
    -1,    -1,    -1,    33,    34,    35,    36,    -1,    -1,    -1,
    -1,    -1,    42,    43,    44,    -1,    46,    47,    -1,    49,
    50,    -1,    -1,    53,    54,    55,    -1,    -1,    -1,    59,
    -1,    61,    62,    -1,    -1,     1,    66,     3,     4,    -1,
    -1,     7,    -1,    -1,    10,    28,    -1,    77,    -1,    15,
    16,    -1,    -1,    19,    -1,    21,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    29,    -1,    -1,    -1,    33,    34,    35,
    36,    -1,    -1,    -1,    -1,    28,    42,    43,    44,    -1,
    46,    47,    -1,    49,    50,    -1,    -1,    53,    54,    55,
    -1,    -1,    75,    59,    -1,    61,    62,    -1,    28,    -1,
    66,    -1,    85,    86,    -1,    -1,    89,    -1,    -1,    -1,
    -1,    77,    95,    96,    97,    -1,    99,   100,   101,   102,
   103,   104,    75,    -1,    -1,    -1,    -1,    -1,    28,    -1,
    -1,    -1,    85,    86,    -1,    -1,    89,    -1,    -1,    -1,
    -1,    -1,    95,    96,    97,    75,    99,   100,   101,   102,
   103,   104,    -1,    -1,    -1,    85,    86,    -1,    28,    89,
    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    -1,    99,
   100,   101,   102,   103,   104,    75,    -1,    -1,    28,    -1,
    -1,    -1,    -1,    -1,    -1,    85,    86,    -1,    -1,    89,
    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    28,    99,
   100,   101,   102,   103,   104,    75,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    85,    86,    -1,    28,    89,
    -1,    -1,    -1,    -1,    -1,    95,    96,    97,    -1,    99,
   100,   101,   102,   103,   104,    85,    86,    -1,    28,    89,
    90,    -1,    -1,    -1,    -1,    95,    96,    97,    -1,    99,
   100,   101,   102,   103,   104,    85,    86,    -1,    -1,    89,
    90,    28,    -1,    -1,    -1,    95,    96,    97,    -1,    99,
   100,   101,   102,   103,   104,    85,    86,    -1,    -1,    89,
    90,    -1,    -1,    -1,    -1,    95,    96,    97,    28,    99,
   100,   101,   102,   103,   104,    85,    86,    -1,    -1,    89,
    90,    -1,    -1,    -1,    -1,    95,    96,    97,    75,    99,
   100,   101,   102,   103,   104,    -1,    -1,    -1,    85,    86,
    -1,    -1,    89,    -1,    -1,    -1,    -1,    -1,    95,    96,
    97,    -1,    99,   100,   101,   102,   103,   104,    -1,    -1,
    80,     4,    -1,    -1,     7,    85,    86,    10,    -1,    89,
    -1,    -1,    15,    16,    -1,    95,    96,    97,    21,    99,
   100,   101,   102,   103,   104,     4,    29,    -1,     7,    -1,
    -1,    10,    35,    -1,    -1,    -1,    15,    16,    -1,    -1,
    -1,     3,    21,    46,    47,    -1,    49,    -1,    -1,    -1,
    29,    -1,    -1,    -1,    -1,    -1,    35,    19,    61,    -1,
    -1,    -1,    -1,    66,    -1,    -1,    -1,    46,    47,    -1,
    49,    33,    34,    -1,    36,    -1,    -1,    -1,    -1,    -1,
    42,    43,    44,    -1,    -1,    -1,    -1,    66,    50,    -1,
    -1,    53,    54,    55,    -1,    -1,    -1,    59,    -1,    83,
    62,    85,    86,    87,    88,    -1,    -1,    91,    92,    93,
    94,    95,    96,    97,    98,    -1,    -1,   101,   102,   103,
   104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
   114,   115,   116,   117,   118
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/sww/share/lib/bison-1.25/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/sww/share/lib/bison-1.25/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 268 "../src/parser.yy"
{ compileAST (yyvsp[0].Tree); ;
    break;}
case 2:
#line 274 "../src/parser.yy"
{ yyval.Tree = new LitNode (intLiteral(*yyvsp[0].Terminal.val), yyvsp[0].Terminal.posn); ;
    break;}
case 3:
#line 276 "../src/parser.yy"
{ yyval.Tree = new LitNode (longLiteral(*yyvsp[0].Terminal.val), yyvsp[0].Terminal.posn); ;
    break;}
case 4:
#line 278 "../src/parser.yy"
{ yyval.Tree = new LitNode (floatLiteral(*yyvsp[0].Terminal.val), yyvsp[0].Terminal.posn); ;
    break;}
case 5:
#line 280 "../src/parser.yy"
{ yyval.Tree = new LitNode (doubleLiteral(*yyvsp[0].Terminal.val), yyvsp[0].Terminal.posn); ;
    break;}
case 6:
#line 282 "../src/parser.yy"
{ yyval.Tree = new LitNode (Literal(true), yyvsp[0].SimpTerminal.posn); ;
    break;}
case 7:
#line 284 "../src/parser.yy"
{ yyval.Tree = new LitNode (Literal(false), yyvsp[0].SimpTerminal.posn); ;
    break;}
case 8:
#line 286 "../src/parser.yy"
{ yyval.Tree = new LitNode (Literal(yyvsp[0].CharTerminal.val), yyvsp[0].CharTerminal.posn); ;
    break;}
case 9:
#line 288 "../src/parser.yy"
{ yyval.Tree = new StringLitNode (*yyvsp[0].StrTerminal.val, yyvsp[0].StrTerminal.posn); ;
    break;}
case 11:
#line 295 "../src/parser.yy"
{ yyval.Type = yyvsp[0].Type; yyval.Type->setElementType(yyvsp[-1].Type); ;
    break;}
case 12:
#line 299 "../src/parser.yy"
{ yyval.Type = yyvsp[-1].Type; yyval.Type->modifiers(yyvsp[0].Modifiers); ;
    break;}
case 14:
#line 305 "../src/parser.yy"
{ yyval.Type = new TypeNameNode (yyvsp[0].Tree); ;
    break;}
case 19:
#line 318 "../src/parser.yy"
{ yyval.Type = yyvsp[-1].Type; yyval.Type->elementType(yyvsp[0].Type); ;
    break;}
case 20:
#line 323 "../src/parser.yy"
{ yyval.Type = new JavaArrayTypeNode(theVoidType); yyval.Type->modifiers(yyvsp[0].Modifiers); ;
    break;}
case 21:
#line 325 "../src/parser.yy"
{ yyval.Type = new TitaniumArrayTypeNode(theVoidType,
						 new LitNode(intLiteral(*yyvsp[-1].Terminal.val)));
	    	  yyval.Type->modifiers(yyvsp[0].Modifiers); 
		  if (yyval.Type->expr()->literal().intValue() <= 0)
		    Error("invalid array dimension " +
			  yyval.Type->expr()->literal().asString(), yyvsp[-1].Terminal.posn);
		;
    break;}
case 23:
#line 336 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers)0; ;
    break;}
case 24:
#line 340 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Single; ;
    break;}
case 25:
#line 341 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Local; ;
    break;}
case 26:
#line 342 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers)(TreeNode::Single | TreeNode::Local); ;
    break;}
case 27:
#line 343 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers)(TreeNode::Single | TreeNode::Local); ;
    break;}
case 28:
#line 348 "../src/parser.yy"
{ yyval.Type = new BoolTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 29:
#line 350 "../src/parser.yy"
{ yyval.Type = new CharTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 30:
#line 352 "../src/parser.yy"
{ yyval.Type = new ByteTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 31:
#line 354 "../src/parser.yy"
{ yyval.Type = new ShortTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 32:
#line 356 "../src/parser.yy"
{ yyval.Type = new IntTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 33:
#line 358 "../src/parser.yy"
{ yyval.Type = new FloatTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 34:
#line 360 "../src/parser.yy"
{ yyval.Type = new LongTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 35:
#line 362 "../src/parser.yy"
{ yyval.Type = new DoubleTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 36:
#line 369 "../src/parser.yy"
{ yyval.Type = new PointTypeNode(yyvsp[-1].Tree); ;
    break;}
case 37:
#line 371 "../src/parser.yy"
{ yyval.Type = new RectDomainTypeNode(yyvsp[-1].Tree); ;
    break;}
case 38:
#line 373 "../src/parser.yy"
{ yyval.Type = new DomainTypeNode(yyvsp[-1].Tree); ;
    break;}
case 39:
#line 383 "../src/parser.yy"
{ yyval.Tree = new CompileUnitNode (NULL, yyvsp[-2].Tree, yyvsp[-1].TreeList, yyvsp[0].TreeList); ;
    break;}
case 40:
#line 388 "../src/parser.yy"
{ yyval.Tree = yyvsp[-1].Tree; ;
    break;}
case 41:
#line 390 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 42:
#line 395 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 43:
#line 397 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[-1].Tree, yyvsp[0].TreeList); ;
    break;}
case 44:
#line 403 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 45:
#line 405 "../src/parser.yy"
{ if (yyvsp[-1].Tree->absent()) yyval.TreeList = yyvsp[0].TreeList; else yyval.TreeList = cons (yyvsp[-1].Tree, yyvsp[0].TreeList); ;
    break;}
case 46:
#line 407 "../src/parser.yy"
{ yyval.TreeList = yyvsp[0].TreeList; ;
    break;}
case 51:
#line 425 "../src/parser.yy"
{ yyval.Tree = new ImportNode (yyvsp[-1].Tree); ;
    break;}
case 52:
#line 434 "../src/parser.yy"
{ yyval.Tree = new ImportOnDemandNode (yyvsp[-3].Tree); ;
    break;}
case 53:
#line 446 "../src/parser.yy"
{ yyval.Tree = new ClassDeclNode (yyvsp[-5].Modifiers, yyvsp[-3].Tree, yyvsp[-2].Tree, yyvsp[-1].TypeList, yyvsp[0].TreeList, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 55:
#line 455 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers) 0; ;
    break;}
case 57:
#line 461 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers) (yyvsp[-1].Modifiers | yyvsp[0].Modifiers); 
		  if ((yyvsp[-1].Modifiers & yyvsp[0].Modifiers) != 0)
		      Error ("repeated modifier", lexerPosition());
	      ;
    break;}
case 58:
#line 470 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Abstract; ;
    break;}
case 59:
#line 472 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Final; ;
    break;}
case 60:
#line 474 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Public; ;
    break;}
case 61:
#line 476 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Immutable; ;
    break;}
case 62:
#line 484 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Type; ;
    break;}
case 63:
#line 486 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 64:
#line 494 "../src/parser.yy"
{ yyval.TypeList = yyvsp[0].TypeList; ;
    break;}
case 65:
#line 496 "../src/parser.yy"
{ yyval.TypeList = NULL; ;
    break;}
case 66:
#line 505 "../src/parser.yy"
{ yyval.TreeList = cons (TreeNode::omitted, yyvsp[-1].TreeList); ;
    break;}
case 68:
#line 511 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 70:
#line 517 "../src/parser.yy"
{ yyval.TreeList = extend (yyvsp[-1].TreeList, yyvsp[0].TreeList); ;
    break;}
case 72:
#line 526 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 73:
#line 528 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 74:
#line 530 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 75:
#line 538 "../src/parser.yy"
{ checkFieldModifiers (yyvsp[-3].Modifiers, yyvsp[-2].Type->position());
	       yyval.TreeList = NULL;
	       foreach (decl, llist<DeclaratorTuple>, *yyvsp[-1].DeclaratorList) {
		   yyval.TreeList = cons (static_cast<TreeNode *>(new FieldDeclNode(makeArrayType(yyvsp[-2].Type, 
										      (*decl).dims),
									(*decl).name,
									yyvsp[-3].Modifiers,
									(*decl).initExpr)),
			      yyval.TreeList);
	       }
	       free_all (yyvsp[-1].DeclaratorList);
	   ;
    break;}
case 77:
#line 562 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers) 0; ;
    break;}
case 79:
#line 568 "../src/parser.yy"
{ yyval.Modifiers = (Common::Modifiers) (yyvsp[-1].Modifiers | yyvsp[0].Modifiers);
		  if ((yyvsp[-1].Modifiers & yyvsp[0].Modifiers) != 0)
		      Error ("repeated modifier", lexerPosition());
	      ;
    break;}
case 80:
#line 577 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Public; ;
    break;}
case 81:
#line 579 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Protected; ;
    break;}
case 82:
#line 581 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Private; ;
    break;}
case 83:
#line 584 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Static; ;
    break;}
case 84:
#line 586 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Final; ;
    break;}
case 85:
#line 588 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Sglobal; ;
    break;}
case 86:
#line 590 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Sglobal; ;
    break;}
case 87:
#line 593 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Abstract; ;
    break;}
case 88:
#line 595 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Native; ;
    break;}
case 89:
#line 597 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Synchronized; ;
    break;}
case 90:
#line 600 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Transient; ;
    break;}
case 91:
#line 602 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Volatile; ;
    break;}
case 92:
#line 604 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Local; ;
    break;}
case 93:
#line 606 "../src/parser.yy"
{ yyval.Modifiers = TreeNode::Inline; ;
    break;}
case 95:
#line 616 "../src/parser.yy"
{ yyval.DeclaratorList = yyvsp[0].DeclaratorList; yyvsp[0].DeclaratorList->tail() = yyvsp[-2].DeclaratorList; ;
    break;}
case 96:
#line 621 "../src/parser.yy"
{ yyval.DeclaratorList = cons(DeclaratorTuple(yyvsp[0].Int, yyvsp[-1].Tree, TreeNode::omitted)); ;
    break;}
case 97:
#line 623 "../src/parser.yy"
{ yyval.DeclaratorList = cons(DeclaratorTuple(yyvsp[-2].Int, yyvsp[-3].Tree, yyvsp[0].Tree)); ;
    break;}
case 100:
#line 639 "../src/parser.yy"
{ checkMethodModifiers(yyvsp[-9].Modifiers, yyvsp[-7].Tree->position());
	    TreeNode *body = addSynchronized(yyvsp[-9].Modifiers, yyvsp[0].Tree);
	    yyval.Tree = new MethodDeclNode(yyvsp[-9].Modifiers, yyvsp[-5].TreeList, makeArrayType(yyvsp[-8].Type, yyvsp[-3].Int), yyvsp[-7].Tree, yyvsp[-2].TypeList, yyvsp[-1].TreeList, body); 
	    ;
    break;}
case 101:
#line 645 "../src/parser.yy"
{ checkMethodModifiers(yyvsp[-9].Modifiers, yyvsp[-7].Tree->position());
	    TreeNode *body = addSynchronized(yyvsp[-9].Modifiers, yyvsp[0].Tree);
	    yyval.Tree = new MethodDeclNode(yyvsp[-9].Modifiers, yyvsp[-5].TreeList, makeArrayType(yyvsp[-8].Type, yyvsp[-3].Int), yyvsp[-7].Tree, yyvsp[-2].TypeList, yyvsp[-1].TreeList, body); 
	    if (yyvsp[-3].Int) Error("cannot return array of void", yyvsp[-7].Tree->position());
	    ;
    break;}
case 104:
#line 659 "../src/parser.yy"
{ yyval.Type = new VoidTypeNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 105:
#line 662 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 106:
#line 663 "../src/parser.yy"
{ yyval.TreeList = cons(yyvsp[-1].Tree, yyvsp[0].TreeList); ;
    break;}
case 107:
#line 668 "../src/parser.yy"
{ yyval.Tree = new OverlapNode(yyvsp[-3].Tree, yyvsp[-1].Tree, yyvsp[-5].SimpTerminal.posn); ;
    break;}
case 109:
#line 679 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 110:
#line 684 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 111:
#line 686 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[-2].Tree, yyvsp[0].TreeList); ;
    break;}
case 112:
#line 691 "../src/parser.yy"
{ yyval.Tree = new ParameterNode (makeArrayType (yyvsp[-2].Type, yyvsp[0].Int), yyvsp[-1].Tree); ;
    break;}
case 114:
#line 700 "../src/parser.yy"
{ yyval.TypeList = NULL; ;
    break;}
case 115:
#line 705 "../src/parser.yy"
{ yyval.TypeList = yyvsp[0].TypeList; ;
    break;}
case 116:
#line 710 "../src/parser.yy"
{ yyval.TypeList = cons (yyvsp[0].Type); ;
    break;}
case 117:
#line 712 "../src/parser.yy"
{ yyval.TypeList = cons (yyvsp[-2].Type, yyvsp[0].TypeList); ;
    break;}
case 119:
#line 721 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 120:
#line 730 "../src/parser.yy"
{ checkConstructorModifiers (yyvsp[-9].Modifiers, yyvsp[-8].Tree->position());
	      yyval.Tree = new ConstructorDeclNode (yyvsp[-9].Modifiers, yyvsp[-6].TreeList, yyvsp[-8].Tree, yyvsp[-4].TypeList, yyvsp[-2].Tree, 
					    new BlockNode (yyvsp[-1].TreeList, yyvsp[0].SimpTerminal.posn));
	    ;
    break;}
case 121:
#line 736 "../src/parser.yy"
{ checkConstructorModifiers (yyvsp[-8].Modifiers, yyvsp[-7].Tree->position ());
	      yyval.Tree = new ConstructorDeclNode (yyvsp[-8].Modifiers, yyvsp[-5].TreeList, yyvsp[-7].Tree, yyvsp[-3].TypeList,
					    new SuperConstructorCallNode (NULL, NULL,
									  yyvsp[-7].Tree->position()),
					    new BlockNode (yyvsp[-1].TreeList, yyvsp[0].SimpTerminal.posn));
	  ;
    break;}
case 124:
#line 755 "../src/parser.yy"
{ yyval.Tree = new ThisConstructorCallNode (yyvsp[-2].TreeList, NULL, false, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 125:
#line 760 "../src/parser.yy"
{ yyval.Tree = new SuperConstructorCallNode (yyvsp[-2].TreeList, NULL, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 126:
#line 768 "../src/parser.yy"
{ yyval.Tree = new StaticInitNode (yyvsp[0].Tree); ;
    break;}
case 127:
#line 777 "../src/parser.yy"
{ checkInterfaceModifiers(yyvsp[-4].Modifiers, yyvsp[-3].SimpTerminal.posn);
	        yyval.Tree = new InterfaceDeclNode (yyvsp[-4].Modifiers, yyvsp[-2].Tree, yyvsp[-1].TypeList, yyvsp[0].TreeList); ;
    break;}
case 129:
#line 787 "../src/parser.yy"
{ yyval.TypeList = NULL; ;
    break;}
case 130:
#line 792 "../src/parser.yy"
{ yyval.TypeList = yyvsp[0].TypeList; ;
    break;}
case 131:
#line 799 "../src/parser.yy"
{ yyval.TreeList = yyvsp[-1].TreeList; ;
    break;}
case 132:
#line 804 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 133:
#line 806 "../src/parser.yy"
{ yyval.TreeList = extend (yyvsp[-1].TreeList, yyvsp[0].TreeList); ;
    break;}
case 135:
#line 812 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 136:
#line 817 "../src/parser.yy"
{ checkConstantFieldModifiers (yyvsp[-3].Modifiers, yyvsp[-2].Type->position());
	       yyval.TreeList = NULL;
	       foreach (decl, llist<DeclaratorTuple>, *yyvsp[-1].DeclaratorList) {
		   yyval.TreeList = cons (static_cast<TreeNode*>(new FieldDeclNode (makeArrayType (yyvsp[-2].Type, 
										       (*decl).dims),
									(*decl).name,
									yyvsp[-3].Modifiers,
									(*decl).initExpr)),
			      yyval.TreeList);
	       }
	       free_all (yyvsp[-1].DeclaratorList);
	   ;
    break;}
case 137:
#line 834 "../src/parser.yy"
{ checkMethodSignatureModifiers (yyvsp[-8].Modifiers, yyvsp[-7].Type->position());
	      yyval.Tree = new MethodSignatureNode (yyvsp[-8].Modifiers, yyvsp[-4].TreeList, 
					    makeArrayType (yyvsp[-7].Type, yyvsp[-2].Int),
					    yyvsp[-6].Tree, yyvsp[-1].TypeList); ;
    break;}
case 138:
#line 840 "../src/parser.yy"
{ checkMethodSignatureModifiers (yyvsp[-8].Modifiers, yyvsp[-7].Type->position());
	      yyval.Tree = new MethodSignatureNode (yyvsp[-8].Modifiers, yyvsp[-4].TreeList, 
					    makeArrayType (yyvsp[-7].Type, yyvsp[-2].Int),
					    yyvsp[-6].Tree, yyvsp[-1].TypeList); ;
    break;}
case 139:
#line 853 "../src/parser.yy"
{ yyval.Tree = new ArrayInitNode (dreverse (yyvsp[-1].TreeList), yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 140:
#line 855 "../src/parser.yy"
{ yyval.Tree = new ArrayInitNode (dreverse (yyvsp[-2].TreeList), yyvsp[-3].SimpTerminal.posn); ;
    break;}
case 141:
#line 857 "../src/parser.yy"
{ yyval.Tree = new ArrayInitNode (NULL, yyvsp[-1].SimpTerminal.posn); ;
    break;}
case 142:
#line 864 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 143:
#line 866 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree, yyvsp[-2].TreeList); ;
    break;}
case 146:
#line 881 "../src/parser.yy"
{ yyval.Tree = new BlockNode (yyvsp[-1].TreeList, yyvsp[0].SimpTerminal.posn); ;
    break;}
case 148:
#line 887 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 149:
#line 892 "../src/parser.yy"
{ yyval.TreeList = yyvsp[0].TreeList; ;
    break;}
case 150:
#line 894 "../src/parser.yy"
{ yyval.TreeList = extend (yyvsp[-1].TreeList, yyvsp[0].TreeList); ;
    break;}
case 151:
#line 899 "../src/parser.yy"
{ yyval.TreeList = yyvsp[0].TreeList; ;
    break;}
case 152:
#line 901 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 153:
#line 909 "../src/parser.yy"
{ yyval.TreeList = NULL;
	       foreach (decl, llist<DeclaratorTuple>, *yyvsp[-1].DeclaratorList) {
		   yyval.TreeList = cons (static_cast<TreeNode*>(new VarDeclNode (makeArrayType (yyvsp[-2].Type, 
										     (*decl).dims),
								      (*decl).name,
								      (*decl).initExpr)),
			      yyval.TreeList);
	       }
	       free_all (yyvsp[-1].DeclaratorList);
	   ;
    break;}
case 163:
#line 939 "../src/parser.yy"
{ yyval.Tree = new EmptyStmtNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 164:
#line 947 "../src/parser.yy"
{ yyval.Tree = new LabeledStmtNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 165:
#line 955 "../src/parser.yy"
{ yyval.Tree = new ExpressionStmtNode( yyvsp[-1].Tree ); ;
    break;}
case 166:
#line 960 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 167:
#line 962 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 168:
#line 964 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 169:
#line 966 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 170:
#line 968 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 171:
#line 970 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 172:
#line 972 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 173:
#line 980 "../src/parser.yy"
{ yyval.Tree = new IfStmtNode (yyvsp[-2].Tree, yyvsp[0].Tree, TreeNode::omitted); ;
    break;}
case 174:
#line 982 "../src/parser.yy"
{ yyval.Tree = new IfStmtNode (yyvsp[-4].Tree, yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 175:
#line 984 "../src/parser.yy"
{ yyval.Tree = new SwitchNode (yyvsp[-2].Tree, yyvsp[0].TreeList, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 176:
#line 989 "../src/parser.yy"
{ yyval.TreeList = yyvsp[-1].TreeList; ;
    break;}
case 177:
#line 993 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 178:
#line 995 "../src/parser.yy"
{ yyval.TreeList = cons (static_cast<TreeNode*>(new SwitchBranchNode (yyvsp[-2].TreeList, yyvsp[-1].TreeList)), yyvsp[0].TreeList); ;
    break;}
case 179:
#line 1000 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 180:
#line 1002 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[-1].Tree, yyvsp[0].TreeList); ;
    break;}
case 181:
#line 1006 "../src/parser.yy"
{ yyval.Tree = new CaseNode (yyvsp[-1].Tree, yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 182:
#line 1008 "../src/parser.yy"
{ yyval.Tree = new CaseNode (TreeNode::omitted, yyvsp[-1].SimpTerminal.posn); ;
    break;}
case 183:
#line 1016 "../src/parser.yy"
{ yyval.Tree = new WhileNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 184:
#line 1018 "../src/parser.yy"
{ yyval.Tree = new DoNode (yyvsp[-5].Tree, yyvsp[-2].Tree); ;
    break;}
case 185:
#line 1020 "../src/parser.yy"
{ yyval.Tree = new ForNode (yyvsp[-5].TreeList, yyvsp[-4].Tree, yyvsp[-2].TreeList, yyvsp[0].Tree); ;
    break;}
case 187:
#line 1026 "../src/parser.yy"
{ yyval.TreeList = yyvsp[-1].TreeList; ;
    break;}
case 188:
#line 1028 "../src/parser.yy"
{ yyval.TreeList = yyvsp[0].TreeList; ;
    break;}
case 190:
#line 1034 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 192:
#line 1040 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 193:
#line 1045 "../src/parser.yy"
{ yyval.TreeList = cons (static_cast<TreeNode *>(new ExpressionStmtNode(yyvsp[0].Tree))); ;
    break;}
case 194:
#line 1047 "../src/parser.yy"
{ yyval.TreeList = cons (static_cast<TreeNode *>(new ExpressionStmtNode(yyvsp[-2].Tree)), yyvsp[0].TreeList); ;
    break;}
case 195:
#line 1054 "../src/parser.yy"
{ yyval.Tree = new ForEachStmtNode (yyvsp[-3].TreeList, yyvsp[0].Tree, yyvsp[-1].Bool, yyvsp[-5].SimpTerminal.posn); ;
    break;}
case 196:
#line 1058 "../src/parser.yy"
{ yyval.Bool = true; ;
    break;}
case 197:
#line 1059 "../src/parser.yy"
{ yyval.Bool = false; ;
    break;}
case 198:
#line 1064 "../src/parser.yy"
{ yyval.TreeList = cons(static_cast<TreeNode *>(new ForEachPairNode(yyvsp[-2].Tree, yyvsp[0].Tree))); ;
    break;}
case 199:
#line 1066 "../src/parser.yy"
{ yyval.TreeList = cons(static_cast<TreeNode *>(new ForEachPairNode(yyvsp[-4].Tree, yyvsp[-2].Tree)), yyvsp[0].TreeList); ;
    break;}
case 200:
#line 1070 "../src/parser.yy"
{ ;
    break;}
case 201:
#line 1072 "../src/parser.yy"
{ if (*yyvsp[0].Terminal.val != "in")
	      	    Error("bad keyword in foreach - expected 'in'",
			  lexerPosition());
	  	;
    break;}
case 202:
#line 1082 "../src/parser.yy"
{ yyval.Tree = new BreakNode (yyvsp[-1].Tree, NULL, yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 203:
#line 1084 "../src/parser.yy"
{ yyval.Tree = new ContinueNode (yyvsp[-1].Tree, NULL, yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 204:
#line 1086 "../src/parser.yy"
{ yyval.Tree = new ReturnNode (yyvsp[-1].Tree, yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 205:
#line 1088 "../src/parser.yy"
{ yyval.Tree = new ThrowNode (yyvsp[-1].Tree, yyvsp[-2].SimpTerminal.posn); ;
    break;}
case 207:
#line 1095 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 208:
#line 1103 "../src/parser.yy"
{ yyval.Tree = new SynchronizedNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 209:
#line 1106 "../src/parser.yy"
{ yyval.Tree = new TryStmtNode (yyvsp[-1].Try, NULL, yyvsp[0].Tree); ;
    break;}
case 210:
#line 1108 "../src/parser.yy"
{ yyval.Tree = new TryStmtNode (yyvsp[-1].Try, yyvsp[0].CatchList, TreeNode::omitted); ;
    break;}
case 211:
#line 1110 "../src/parser.yy"
{ yyval.Tree = new TryStmtNode (yyvsp[-2].Try, yyvsp[-1].CatchList, yyvsp[0].Tree); ;
    break;}
case 212:
#line 1115 "../src/parser.yy"
{ yyval.Try = new TryNode (yyvsp[0].Tree); ;
    break;}
case 213:
#line 1119 "../src/parser.yy"
{ yyval.CatchList = cons (yyvsp[0].Catch); ;
    break;}
case 214:
#line 1121 "../src/parser.yy"
{ yyval.CatchList = cons (yyvsp[-1].Catch, yyvsp[0].CatchList); ;
    break;}
case 215:
#line 1126 "../src/parser.yy"
{ yyval.Catch = new CatchNode (yyvsp[-2].Tree, yyvsp[0].Tree, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 216:
#line 1131 "../src/parser.yy"
{ yyval.Tree = new FinallyNode( yyvsp[0].Tree ); ;
    break;}
case 217:
#line 1138 "../src/parser.yy"
{ yyval.Tree = new PartitionStmtNode(TreeNode::omitted, yyvsp[-1].TreeList, yyvsp[-3].SimpTerminal.posn); ;
    break;}
case 218:
#line 1140 "../src/parser.yy"
{ yyval.Tree = new PartitionStmtNode(yyvsp[-3].Tree, yyvsp[-1].TreeList, yyvsp[-4].SimpTerminal.posn); ;
    break;}
case 219:
#line 1144 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 220:
#line 1146 "../src/parser.yy"
{ yyval.TreeList = cons(static_cast<TreeNode *>(new PartitionClauseNode(yyvsp[-3].Tree, yyvsp[-1].Tree)),
					    yyvsp[0].TreeList); ;
    break;}
case 221:
#line 1158 "../src/parser.yy"
{ yyval.Tree = new ObjectNode (yyvsp[0].Tree); ;
    break;}
case 226:
#line 1170 "../src/parser.yy"
{ yyval.Tree = new NullPntrNode (yyvsp[0].SimpTerminal.posn); ;
    break;}
case 227:
#line 1172 "../src/parser.yy"
{ yyval.Tree = new ThisNode (NULL, false, yyvsp[0].SimpTerminal.posn); ;
    break;}
case 228:
#line 1174 "../src/parser.yy"
{ yyval.Tree = yyvsp[-1].Tree; ;
    break;}
case 229:
#line 1176 "../src/parser.yy"
{ yyval.Tree = new ObjectNode (yyvsp[-1].Tree); ;
    break;}
case 231:
#line 1179 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 235:
#line 1194 "../src/parser.yy"
{ yyval.Tree =
		    new NameNode (TreeNode::omitted, yyvsp[0].Terminal.val, NULL, yyvsp[0].Terminal.posn); ;
    break;}
case 236:
#line 1200 "../src/parser.yy"
{ yyval.Tree = new NameNode (yyvsp[-2].Tree, yyvsp[0].Terminal.val, NULL, yyvsp[0].Terminal.posn); ;
    break;}
case 237:
#line 1204 "../src/parser.yy"
{ yyval.Tree = newOperator("!", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 238:
#line 1205 "../src/parser.yy"
{ yyval.Tree = newOperator("~", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 239:
#line 1206 "../src/parser.yy"
{ yyval.Tree = newOperator("<", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 240:
#line 1207 "../src/parser.yy"
{ yyval.Tree = newOperator(">", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 241:
#line 1208 "../src/parser.yy"
{ yyval.Tree = newOperator("<=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 242:
#line 1209 "../src/parser.yy"
{ yyval.Tree = newOperator(">=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 243:
#line 1210 "../src/parser.yy"
{ yyval.Tree = newOperator("==", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 244:
#line 1211 "../src/parser.yy"
{ yyval.Tree = newOperator("!=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 245:
#line 1212 "../src/parser.yy"
{ yyval.Tree = newOperator("+", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 246:
#line 1213 "../src/parser.yy"
{ yyval.Tree = newOperator("-", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 247:
#line 1214 "../src/parser.yy"
{ yyval.Tree = newOperator("*", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 248:
#line 1215 "../src/parser.yy"
{ yyval.Tree = newOperator("/", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 249:
#line 1216 "../src/parser.yy"
{ yyval.Tree = newOperator("&", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 250:
#line 1217 "../src/parser.yy"
{ yyval.Tree = newOperator("|", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 251:
#line 1218 "../src/parser.yy"
{ yyval.Tree = newOperator("^", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 252:
#line 1219 "../src/parser.yy"
{ yyval.Tree = newOperator("%", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 253:
#line 1220 "../src/parser.yy"
{ yyval.Tree = newOperator("<<", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 254:
#line 1221 "../src/parser.yy"
{ yyval.Tree = newOperator(">>", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 255:
#line 1222 "../src/parser.yy"
{ yyval.Tree = newOperator(">>>", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 256:
#line 1223 "../src/parser.yy"
{ yyval.Tree = newOperator("+=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 257:
#line 1224 "../src/parser.yy"
{ yyval.Tree = newOperator("-=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 258:
#line 1225 "../src/parser.yy"
{ yyval.Tree = newOperator("*=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 259:
#line 1226 "../src/parser.yy"
{ yyval.Tree = newOperator("/=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 260:
#line 1227 "../src/parser.yy"
{ yyval.Tree = newOperator("%=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 261:
#line 1228 "../src/parser.yy"
{ yyval.Tree = newOperator("<<=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 262:
#line 1229 "../src/parser.yy"
{ yyval.Tree = newOperator(">>=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 263:
#line 1230 "../src/parser.yy"
{ yyval.Tree = newOperator(">>>=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 264:
#line 1231 "../src/parser.yy"
{ yyval.Tree = newOperator("&=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 265:
#line 1232 "../src/parser.yy"
{ yyval.Tree = newOperator("^=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 266:
#line 1233 "../src/parser.yy"
{ yyval.Tree = newOperator("|=", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 267:
#line 1234 "../src/parser.yy"
{ yyval.Tree = newOperator("[]", yyvsp[0].SimpTerminal.posn); ;
    break;}
case 268:
#line 1235 "../src/parser.yy"
{ yyval.Tree = newOperator("[]=", yyvsp[-1].SimpTerminal.posn); ;
    break;}
case 269:
#line 1242 "../src/parser.yy"
{ yyval.Tree = new ArrayAccessNode (new ObjectNode (yyvsp[-3].Tree), yyvsp[-1].Tree); ;
    break;}
case 270:
#line 1244 "../src/parser.yy"
{ yyval.Tree = new ArrayAccessNode (yyvsp[-3].Tree, yyvsp[-1].Tree); ;
    break;}
case 271:
#line 1248 "../src/parser.yy"
{ yyval.Tree = new PointNode(yyvsp[0].TreeList); ;
    break;}
case 272:
#line 1257 "../src/parser.yy"
{ yyval.Tree = new ObjectFieldAccessNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 273:
#line 1259 "../src/parser.yy"
{ yyval.Tree = new SuperFieldAccessNode (NULL, false, yyvsp[0].Tree); ;
    break;}
case 274:
#line 1261 "../src/parser.yy"
{ yyval.Tree = new TypeFieldAccessNode (yyvsp[-2].Type, yyvsp[0].Tree); ;
    break;}
case 275:
#line 1263 "../src/parser.yy"
{ yyval.Tree = new ObjectFieldAccessNode (new ObjectNode(yyvsp[-2].Tree), yyvsp[0].Tree); ;
    break;}
case 276:
#line 1265 "../src/parser.yy"
{ yyval.Tree = new ThisFieldAccessNode (NULL, false, yyvsp[0].Tree); ;
    break;}
case 277:
#line 1273 "../src/parser.yy"
{ yyval.Tree = new MethodCallNode (yyvsp[-3].Tree, yyvsp[-1].TreeList); ;
    break;}
case 278:
#line 1275 "../src/parser.yy"
{ yyval.Tree = new MethodCallNode (new ObjectNode (yyvsp[-3].Tree), yyvsp[-1].TreeList); ;
    break;}
case 280:
#line 1281 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 281:
#line 1286 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 282:
#line 1288 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[-2].Tree, yyvsp[0].TreeList); ;
    break;}
case 283:
#line 1296 "../src/parser.yy"
{ yyval.Tree = new AllocateNode (yyvsp[-4].Tree, yyvsp[-3].Type, yyvsp[-1].TreeList, NULL); ;
    break;}
case 284:
#line 1298 "../src/parser.yy"
{ yyval.Tree = new AllocateArrayNode (yyvsp[-2].Tree, yyvsp[-1].Type, yyvsp[0].TreeList); ;
    break;}
case 285:
#line 1300 "../src/parser.yy"
{ yyval.Tree = new AllocateArrayNode (yyvsp[-3].Tree, yyvsp[0].Type, yyvsp[-1].TreeList); yyvsp[0].Type->setElementType(yyvsp[-2].Type); ;
    break;}
case 286:
#line 1305 "../src/parser.yy"
{ yyval.Tree = yyvsp[-1].Tree; ;
    break;}
case 287:
#line 1307 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 288:
#line 1312 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[0].Tree); ;
    break;}
case 289:
#line 1314 "../src/parser.yy"
{ yyval.TreeList = cons (yyvsp[-1].Tree, yyvsp[0].TreeList); ;
    break;}
case 290:
#line 1319 "../src/parser.yy"
{ yyval.Tree = new AllocateArrayDimensionNode(yyvsp[-2].Tree, yyvsp[0].Modifiers); ;
    break;}
case 291:
#line 1321 "../src/parser.yy"
{ yyval.Tree = new AllocateArrayDimensionNode(yyvsp[-1].Tree, yyvsp[0].Modifiers); ;
    break;}
case 293:
#line 1327 "../src/parser.yy"
{ yyval.Int = 0; ;
    break;}
case 294:
#line 1332 "../src/parser.yy"
{ yyval.Int = 1; ;
    break;}
case 295:
#line 1334 "../src/parser.yy"
{ yyval.Int = 1; ;
    break;}
case 296:
#line 1336 "../src/parser.yy"
{ yyval.Int = yyvsp[-1].Int + 1; ;
    break;}
case 297:
#line 1338 "../src/parser.yy"
{ yyval.Int = yyvsp[-2].Int + 1; ;
    break;}
case 301:
#line 1352 "../src/parser.yy"
{ yyval.Tree = new PostIncrNode (yyvsp[-1].Tree); ;
    break;}
case 302:
#line 1357 "../src/parser.yy"
{ yyval.Tree = new PostDecrNode (yyvsp[-1].Tree); ;
    break;}
case 305:
#line 1367 "../src/parser.yy"
{ yyval.Tree = new UnaryPlusNode (yyvsp[0].Tree, yyvsp[-1].SimpTerminal.posn); ;
    break;}
case 306:
#line 1369 "../src/parser.yy"
{ yyval.Tree = new UnaryMinusNode (yyvsp[0].Tree, yyvsp[-1].SimpTerminal.posn); ;
    break;}
case 310:
#line 1377 "../src/parser.yy"
{ yyval.Tree = new PreIncrNode (yyvsp[0].Tree); ;
    break;}
case 311:
#line 1382 "../src/parser.yy"
{ yyval.Tree = new PreDecrNode (yyvsp[0].Tree); ;
    break;}
case 313:
#line 1388 "../src/parser.yy"
{ yyval.Tree = new ComplementNode (yyvsp[0].Tree); ;
    break;}
case 314:
#line 1390 "../src/parser.yy"
{ yyval.Tree = new NotNode (yyvsp[0].Tree); ;
    break;}
case 316:
#line 1396 "../src/parser.yy"
{ yyval.Tree = new CastNode (yyvsp[0].Tree, yyvsp[-2].Type); ;
    break;}
case 317:
#line 1398 "../src/parser.yy"
{ yyval.Tree = new CastNode (yyvsp[0].Tree, new TypeNameNode (yyvsp[-2].Tree)); ;
    break;}
case 318:
#line 1408 "../src/parser.yy"
{ yyval.Tree = new PointNode(yyvsp[-1].TreeList); ;
    break;}
case 319:
#line 1412 "../src/parser.yy"
{ yyval.Tree = new DomainNode(yyvsp[-1].TreeList); ;
    break;}
case 320:
#line 1413 "../src/parser.yy"
{ yyval.Tree = new DomainNode(yyvsp[-1].TreeList); ;
    break;}
case 321:
#line 1417 "../src/parser.yy"
{ yyval.TreeList = cons(yyvsp[0].Tree); ;
    break;}
case 322:
#line 1418 "../src/parser.yy"
{ yyval.TreeList = cons(yyvsp[-2].Tree, yyvsp[0].TreeList); ;
    break;}
case 323:
#line 1423 "../src/parser.yy"
{ yyval.Tree = new TreeListNode(cons(yyvsp[-2].Tree, cons(yyvsp[0].Tree))); ;
    break;}
case 324:
#line 1427 "../src/parser.yy"
{ yyval.TreeList = cons(yyvsp[0].Tree); ;
    break;}
case 325:
#line 1428 "../src/parser.yy"
{ yyval.TreeList = cons(yyvsp[-2].Tree, yyvsp[0].TreeList); ;
    break;}
case 326:
#line 1433 "../src/parser.yy"
{ yyval.Tree = new TreeListNode(cons(yyvsp[-4].Tree, cons(yyvsp[-2].Tree, cons(yyvsp[0].Tree)))); ;
    break;}
case 328:
#line 1441 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 331:
#line 1448 "../src/parser.yy"
{ yyval.Tree = new LTNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 332:
#line 1450 "../src/parser.yy"
{ yyval.Tree = new GTNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 333:
#line 1452 "../src/parser.yy"
{ yyval.Tree = new LENode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 334:
#line 1454 "../src/parser.yy"
{ yyval.Tree = new GENode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 335:
#line 1456 "../src/parser.yy"
{ yyval.Tree = new InstanceOfNode (yyvsp[-2].Tree, yyvsp[0].Type); ;
    break;}
case 336:
#line 1458 "../src/parser.yy"
{ yyval.Tree = new EQNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 337:
#line 1460 "../src/parser.yy"
{ yyval.Tree = new NENode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 338:
#line 1462 "../src/parser.yy"
{ yyval.Tree = new BitAndNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 339:
#line 1464 "../src/parser.yy"
{ yyval.Tree = new BitOrNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 340:
#line 1466 "../src/parser.yy"
{ yyval.Tree = new BitXorNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 341:
#line 1468 "../src/parser.yy"
{ yyval.Tree = new CandNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 342:
#line 1470 "../src/parser.yy"
{ yyval.Tree = new CorNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 343:
#line 1472 "../src/parser.yy"
{ yyval.Tree = new IfExprNode (yyvsp[-4].Tree, yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 346:
#line 1479 "../src/parser.yy"
{ yyval.Tree = new MultNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 347:
#line 1481 "../src/parser.yy"
{ yyval.Tree = new DivNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 348:
#line 1483 "../src/parser.yy"
{ yyval.Tree = new RemNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 349:
#line 1485 "../src/parser.yy"
{ yyval.Tree = new PlusNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 350:
#line 1487 "../src/parser.yy"
{ yyval.Tree = new MinusNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 351:
#line 1489 "../src/parser.yy"
{ yyval.Tree = new LeftShiftLogNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 352:
#line 1491 "../src/parser.yy"
{ yyval.Tree = new RightShiftLogNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 353:
#line 1493 "../src/parser.yy"
{ yyval.Tree = new RightShiftArithNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 354:
#line 1501 "../src/parser.yy"
{ yyval.Tree = new AssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 355:
#line 1503 "../src/parser.yy"
{ yyval.Tree = new MultAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 356:
#line 1505 "../src/parser.yy"
{ yyval.Tree = new DivAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 357:
#line 1507 "../src/parser.yy"
{ yyval.Tree = new RemAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 358:
#line 1509 "../src/parser.yy"
{ yyval.Tree = new PlusAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 359:
#line 1511 "../src/parser.yy"
{ yyval.Tree = new MinusAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 360:
#line 1513 "../src/parser.yy"
{ yyval.Tree = new LeftShiftLogAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 361:
#line 1515 "../src/parser.yy"
{ yyval.Tree = new RightShiftLogAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 362:
#line 1517 "../src/parser.yy"
{ yyval.Tree = new RightShiftArithAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 363:
#line 1519 "../src/parser.yy"
{ yyval.Tree = new BitAndAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 364:
#line 1521 "../src/parser.yy"
{ yyval.Tree = new BitXorAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 365:
#line 1523 "../src/parser.yy"
{ yyval.Tree = new BitOrAssignNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 367:
#line 1535 "../src/parser.yy"
{ yyval.Tree = new BroadcastNode (yyvsp[-2].Tree, yyvsp[0].Tree); ;
    break;}
case 369:
#line 1548 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 370:
#line 1553 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 371:
#line 1558 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
case 372:
#line 1563 "../src/parser.yy"
{ yyval.Tree = new EmptyStmtNode; ;
    break;}
case 373:
#line 1565 "../src/parser.yy"
{ yyval.Tree = yyvsp[0].Tree; ;
    break;}
case 374:
#line 1570 "../src/parser.yy"
{ yyval.TreeList = NULL; ;
    break;}
case 375:
#line 1575 "../src/parser.yy"
{ yyval.Tree = TreeNode::omitted; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/sww/share/lib/bison-1.25/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1579 "../src/parser.yy"


static void yyerror(const char* msg)
{
  Error(msg, yylval.SimpTerminal.posn);
}

static TreeNode *newOperator(char *op, SourcePosn p)
{
  return new NameNode(TreeNode::omitted, intern(op), NULL, p);
}

/* Check that FLAG is not a member of FLAGS.  If it is, report an */
/* error at POSN, giving NAME as the name of the offending modifier. */
static void checkModifier(SourcePosn posn, Common::Modifiers flags,
			  Common::Modifiers flag, const char* name)
{
  if (((unsigned long) flags & (unsigned long) flag) != 0)
    Error (string("illegal modifier: '") + name + "'", posn);
}

/* Check that only the modifiers in ... are in FLAGS, reporting an */
/* error at POSN if not. */
static void checkModifiers(SourcePosn posn, Common::Modifiers flags, ...)
{
  unsigned long flag;
  va_list ap;

  va_start (ap, flags);
  while (true) {
    flag = va_arg (ap, unsigned long);
    if (flag == 0)
      break;
    flags = (Common::Modifiers)((unsigned long)flags & ~flag);
  }
  va_end (ap);

  if ((unsigned long) flags != 0)
    Error("illegal modifiers: " + stringifyModifiers(flags), posn);
}

static void checkFieldModifiers(Common::Modifiers flags, 
				SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Protected, TreeNode::Private,
		 TreeNode::Static, TreeNode::Final,
		 TreeNode::Transient, TreeNode::Volatile,
		 (Common::Modifiers) 0);
}

static void checkConstantFieldModifiers(Common::Modifiers flags, 
					SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Static, TreeNode::Final,
		 (Common::Modifiers) 0);
}

static void checkMethodModifiers(Common::Modifiers flags, 
				 SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Protected, TreeNode::Private,
		 TreeNode::Static, TreeNode::Final,
		 TreeNode::Abstract, TreeNode::Native, 
		 TreeNode::Sglobal, TreeNode::Local,
		 TreeNode::Synchronized, TreeNode::Inline,
		 (Common::Modifiers) 0);
}

static void checkConstructorModifiers(Common::Modifiers flags, 
				      SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Protected, TreeNode::Private,
		 TreeNode::Sglobal, TreeNode::Inline,
		 (Common::Modifiers) 0);
}

static void checkMethodSignatureModifiers(Common::Modifiers flags, 
					  SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Abstract,
		 TreeNode::Single, TreeNode::Local,
		 (Common::Modifiers) 0);
}

static void checkInterfaceModifiers(Common::Modifiers flags, 
				    SourcePosn posn)
{
  checkModifiers(posn, flags, 
		 TreeNode::Public, TreeNode::Abstract, 
		 (Common::Modifiers) 0);
}

static TreeNode *addSynchronized(Common::Modifiers modifiers, TreeNode *body)
{
  if ((modifiers & TreeNode::Synchronized) != 0 && !body->absent()) {
    TreeNode *syncObject;
    if ((modifiers & TreeNode::Static) != 0) {
      syncObject = TreeNode::omitted;
    }
    else {
      syncObject = new ThisNode(NULL, false, body->position());
    }
    body = new SynchronizedNode(syncObject, body);
  }
  return body;
}
