typedef union {
    SimpTerminalInfo SimpTerminal;  	/* Terminal symbols with only position. */
    TerminalInfo Terminal;		/* Terminal symbols with ASCII string data. */
    StrTerminalInfo StrTerminal;	/* Terminal symbols with Unicode string data. */
    CharTerminalInfo CharTerminal;	/* Terminal symbols with Unicode char data. */
    long Int;				/* Simple integer values */
    bool Bool;
    TreeNode* Tree;
    TypeNode* Type;
    CatchNode* Catch;
    llist<TreeNode*>* TreeList;
    llist<TypeNode*>* TypeList;
    llist<CatchNode*>* CatchList;
    Common::Modifiers Modifiers;
    llist<DeclaratorTuple>* DeclaratorList;
    TryNode *Try;
} YYSTYPE;
#define	ABSTRACT	258
#define	BOOLEAN	259
#define	BREAK	260
#define	BROADCAST	261
#define	BYTE	262
#define	CASE	263
#define	CATCH	264
#define	CHAR	265
#define	CLASS	266
#define	CONTINUE	267
#define	DEFAULT	268
#define	DO	269
#define	DOUBLE	270
#define	DOMAIN	271
#define	ELSE	272
#define	EXTENDS	273
#define	FINAL	274
#define	FINALLY	275
#define	FLOAT	276
#define	FOR	277
#define	FROM	278
#define	FOREACH	279
#define	IF	280
#define	IMPLEMENTS	281
#define	IMPORT	282
#define	INSTANCEOF	283
#define	INT	284
#define	INTERFACE	285
#define	IMMUTABLE	286
#define	IN	287
#define	INLINE	288
#define	LOCAL	289
#define	LONG	290
#define	NATIVE	291
#define	NEW	292
#define	_NULL	293
#define	OPERATOR	294
#define	OVERLAP	295
#define	_PACKAGE	296
#define	PRIVATE	297
#define	PROTECTED	298
#define	PUBLIC	299
#define	PARTITION	300
#define	POINT	301
#define	RECTDOMAIN	302
#define	RETURN	303
#define	SHORT	304
#define	STATIC	305
#define	SUPER	306
#define	SWITCH	307
#define	SYNCHRONIZED	308
#define	SINGLE	309
#define	SGLOBAL	310
#define	THIS	311
#define	THROW	312
#define	THROWS	313
#define	TRANSIENT	314
#define	TRY	315
#define	VOID	316
#define	VOLATILE	317
#define	WHILE	318
#define	TRUE	319
#define	FALSE	320
#define	IDENTIFIER	321
#define	INT_LITERAL	322
#define	LONG_LITERAL	323
#define	FLOAT_LITERAL	324
#define	DOUBLE_LITERAL	325
#define	DOUBLE_DIM	326
#define	CHARACTER_LITERAL	327
#define	STRING_LITERAL	328
#define	EMPTY_DIM	329
#define	CAND	330
#define	COR	331
#define	EQ	332
#define	NE	333
#define	LE	334
#define	GE	335
#define	LSHIFTL	336
#define	ASHIFTR	337
#define	LSHIFTR	338
#define	PLUS_ASG	339
#define	MINUS_ASG	340
#define	MULT_ASG	341
#define	DIV_ASG	342
#define	REM_ASG	343
#define	LSHIFTL_ASG	344
#define	ASHIFTR_ASG	345
#define	LSHIFTR_ASG	346
#define	AND_ASG	347
#define	XOR_ASG	348
#define	OR_ASG	349
#define	PLUSPLUS	350
#define	MINUSMINUS	351
#define	GUARDS	352


extern YYSTYPE yylval;
