#include <cl_ti_domains_tiRectDomain3.h>
#include <cl_ti_domains_tiRectDomain2.h>

RD2 slice32(RD3  temp_8640, jint temp_8641)
{
  P2 temp_8642, temp_8643, temp_8644;
  P3 slicevar_old_p0, slicevar_old_p1, slicevar_old_stride;
  int slicevar_index, slicevar_count;
  int slicevar_kill_dim = (temp_8641) - 1;
    
  slicevar_old_p0 = cl_ti_domains_tiRectDomain3_mt_getLowerBound(temp_8640);
  slicevar_old_p1 = cl_ti_domains_tiRectDomain3_mt_getUpperBound(temp_8640);
  slicevar_old_stride = cl_ti_domains_tiRectDomain3_mt_getStride(temp_8640);
    
  for (slicevar_index = 0, slicevar_count = 0; slicevar_index < 3; slicevar_index++) {
    if (slicevar_index != slicevar_kill_dim) {
      temp_8642 =
	cl_ti_domains_tiPoint2_mt_set_jint_jint(temp_8642, slicevar_count,
		      cl_ti_domains_tiPoint3_mt_get_jint(slicevar_old_p0, slicevar_index));
      temp_8643 =
	cl_ti_domains_tiPoint2_mt_set_jint_jint(temp_8643, slicevar_count,
		      cl_ti_domains_tiPoint3_mt_get_jint(slicevar_old_p1, slicevar_index));
      temp_8644 =
	cl_ti_domains_tiPoint2_mt_set_jint_jint(temp_8644, slicevar_count,
		      cl_ti_domains_tiPoint3_mt_get_jint(slicevar_old_stride, slicevar_index));
      slicevar_count++;
    }
  }
  return cl_ti_domains_tiRectDomain2_mt_createWithUpbPoint_cl_ti_domains_tiPoint2_cl_ti_domains_tiPoint2_cl_ti_domains_tiPoint2(temp_8642, temp_8643, temp_8644);
}
